﻿using UnityEngine;
using System.Collections.Generic;
using System.Collections;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using HarmonyLib;
using Steamworks;
using System.Reflection;
using System.Linq;
using HMLLibrary;
using System;
using System.IO;
using System.Reflection.Emit;
using System.Globalization;
using Debug = UnityEngine.Debug;
using Object = UnityEngine.Object;
using Random = UnityEngine.Random;

namespace BenevolentSprites
{
    public class BenevolentSprites : Mod
    {
        static BenevolentSprites self = null;
        public static List<HelperSprite> sprites = new List<HelperSprite>();
        public static Traverse<SO_CookingTable_Recipe[]> recipesRef = Traverse.Create<CookingTable>().Field<SO_CookingTable_Recipe[]>("allRecipes");
        public static SO_CookingTable_Recipe[] allRecipes => recipesRef.Value;
        static GameObject firePrefab;
        static Transform prefabHolder;
        public static List<AI_NetworkBehaviour_Domestic_Resource> animals = new List<AI_NetworkBehaviour_Domestic_Resource>();
        public static List<PickupItem_Networked> eggs = new List<PickupItem_Networked>();
        public static List<BeeHive> beehives = new List<BeeHive>();
        public static List<CookingTable> tables = new List<CookingTable>();
        public static List<Block_CookingStand> stands = new List<Block_CookingStand>();
        public static List<CookingTable_Recipe_UI> recipes = new List<CookingTable_Recipe_UI>();
        public static List<Seagull> seagulls = new List<Seagull>();
        public static List<Block_Foundation_ItemNet> itemnets = new List<Block_Foundation_ItemNet>();
        public static List<TankAccess> tanks = new List<TankAccess>();
        public static Traverse<IEnumerable<MonoBehaviour>> fishnets = null;
        Harmony harmony;
        public static List<Message_InitiateConnection> waiting = new List<Message_InitiateConnection>();
        public static bool gameLoaded = false;
        public static Item_Base repellentItem;
        public static Dictionary<string, Item_Base> spriteItems = new Dictionary<string, Item_Base>();
        public static Dictionary<string, ConstructorInfo> spriteTypes = new Dictionary<string, ConstructorInfo>();
        static int keepItem;
        public static int KeepItem => ExtraSettingsAPI_Loaded ? keepItem : 0;
        static bool ec_garden;
        public static bool EC_Garden => ExtraSettingsAPI_Loaded ? ec_garden : false;
        static bool ec_animal;
        public static bool EC_Animal => ExtraSettingsAPI_Loaded ? ec_animal : false;
        static bool ec_animal2;
        public static bool EC_Animal2 => ExtraSettingsAPI_Loaded ? ec_animal2 : false;
        static bool ec_animal3;
        public static bool EC_Animal3 => ExtraSettingsAPI_Loaded ? ec_animal3 : false;
        static bool ec_fire;
        public static bool EC_Fire => ExtraSettingsAPI_Loaded ? ec_fire : false;
        static bool ec_fire2;
        public static bool EC_Fire2 => ExtraSettingsAPI_Loaded ? ec_fire2 : false;
        static bool ec_clean;
        public static bool EC_Clean => ExtraSettingsAPI_Loaded ? ec_clean : false;
        static float spriteRange;
        public static float SpriteRange => ExtraSettingsAPI_Loaded ? spriteRange : 0.5f;
        static float gardenRange;
        public static float GardenRange => ExtraSettingsAPI_Loaded ? gardenRange : 1;
        static float animalRange;
        public static float AnimalRange => ExtraSettingsAPI_Loaded ? animalRange : 1;
        static float fireRange;
        public static float FireRange => ExtraSettingsAPI_Loaded ? fireRange : 1;
        static float fire2Range;
        public static float Fire2Range => ExtraSettingsAPI_Loaded ? fire2Range : 1;
        static float cleanerRange;
        public static float CleanerRange => ExtraSettingsAPI_Loaded ? cleanerRange : 1;
        static float mechanicRange;
        public static float MechanicRange => ExtraSettingsAPI_Loaded ? mechanicRange : 1;
        static float repelRange;
        public static float RepelRange => ExtraSettingsAPI_Loaded ? repelRange : 2.25f;
        public static bool PlaySounds = true;
        static bool ExtraSettingsAPI_Loaded = false;
        public const string dataKey = "SpriteData";
        static bool devMode = false;
        public static GameObject FirePrefab
        {
            get
            {
                if (firePrefab == null)
                    foreach (var p in Resources.FindObjectsOfTypeAll<ParticleSystemRenderer>())
                        if (p.name == "Fire" && p.transform.parent?.name == "Fire_v2")
                        {
                            firePrefab = Instantiate(p.gameObject, prefabHolder, false);
                            var m = firePrefab.GetComponent<ParticleSystem>().main;
                            m.duration *= 2;
                            m.startDelayMultiplier /= 3;
                            //m.simulationSpace = ParticleSystemSimulationSpace.World;
                            break;
                        }
                return firePrefab;
            }
        }
        public void Start()
        {
            self = this;
            if (SceneManager.GetActiveScene().name != Raft_Network.MenuSceneName)
            {
                modlistEntry.modinfo.unloadBtn.GetComponent<Button>().onClick.Invoke();
                throw new ModLoadException("Mod must be loaded on the main menu");
            }
            bool reload = ItemManager.GetItemByName("Sprite_Repellent");
            if (reload)
            {
                repellentItem = ItemManager.GetItemByName("Sprite_Repellent");
                spriteTypes["Garden_Sprite"] = GetConstructor<GardenSprite>();
                spriteTypes["Animal_Sprite"] = GetConstructor<AnimalSprite>();
                spriteTypes["Fire_Sprite"] = GetConstructor<FireSprite>();
                spriteTypes["Fire_Sprite_2"] = GetConstructor<FireSprite2>();
                spriteTypes["Cleaner_Sprite"] = GetConstructor<CleanerSprite>();
                spriteTypes["Mechanic_Sprite"] = GetConstructor<MechanicSprite>();
                foreach (var name in spriteTypes.Keys)
                    spriteItems[name] = ItemManager.GetItemByName(name);
            }
            else
            {
                Action<Texture2D> repelTexture = (texture) =>
                {
                    for (int x = 0; x < texture.width; x++)
                        for (int y = 0; y < texture.height; y++)
                        {
                            var old = texture.GetPixel(x, y);
                            texture.SetPixel(x, y, new Color(old.r, old.b, old.g, old.a));
                        }
                    texture.Apply();
                };
                var originalItem = ItemManager.GetItemByName("Placeable_Lantern_Metal");
                repellentItem = originalItem.Clone(8764, "Sprite_Repellent");
                repellentItem.name = repellentItem.UniqueName;
                repellentItem.settings_Inventory.LocalizationTerm = "";
                repellentItem.settings_Inventory.DisplayName = "Sprite Repellent";
                repellentItem.settings_Inventory.Description = "Deters sprites within a small radius";
                repellentItem.settings_recipe = new ItemInstance_Recipe(CraftingCategory.Other, false, false, "Sprite Repellent", 0);
                repellentItem.settings_recipe.SetRecipe(new CostMultiple[]
                    {
                    new CostMultiple(new Item_Base[] {ItemManager.GetItemByName("Scrap") }, 2 ),
                    new CostMultiple(new Item_Base[] {ItemManager.GetItemByName("Glass")},1)
                    }, 2);
                repellentItem.settings_recipe.LearnedViaBlueprint = true;
                prefabHolder = new GameObject("prefabHolder").transform;
                prefabHolder.gameObject.SetActive(false);
                DontDestroyOnLoad(prefabHolder.gameObject);
                var prefabs = Traverse.Create(repellentItem.settings_buildable).Field<Block[]>("blockPrefabs");
                var newPrefabs = new Block[prefabs.Value.Length];
                for (int i = 0; i < prefabs.Value.Length; i++)
                {
                    newPrefabs[i] = Instantiate(prefabs.Value[i], prefabHolder, false);
                    newPrefabs[i].gameObject.AddComponent<SpriteRepellent>();
                    DestroyImmediate(newPrefabs[i].GetComponent<LightSingularityExternal>());
                    var lightObj = new GameObject("lightEmitter");
                    lightObj.transform.SetParent(newPrefabs[i].transform, false);
                    lightObj.transform.localPosition = Vector3.up * 0.1f;
                    var light = lightObj.AddComponent<Light>();
                    light.color = new Color(1, 0, 1, 0.6f);
                    light.intensity = 3;
                    light.range = 1;
                    newPrefabs[i].itemToReturnOnDestroy = repellentItem;
                    newPrefabs[i].buildableItem = repellentItem;
                    foreach (var rend in newPrefabs[i].GetComponentsInChildren<MeshRenderer>())
                    {
                        rend.material = new Material(rend.material);
                        var tex = ((Texture2D)rend.material.GetTexture(298)).GetReadable();
                        rend.material.SetTexture(298, tex);
                        repelTexture(tex);
                    }
                    newPrefabs[i].name = repellentItem.UniqueName;
                }
                prefabs.Value = newPrefabs;
                Traverse.Create(repellentItem.settings_Inventory).Field("stackSize").SetValue(10);
                repellentItem.settings_Inventory.Sprite = originalItem.settings_Inventory.Sprite.GetReadable();
                repelTexture(repellentItem.settings_Inventory.Sprite.texture);
                foreach (var type in Resources.FindObjectsOfTypeAll<SO_BlockQuadType>())
                    if (type.AcceptsBlock(originalItem))
                        Traverse.Create(type).Field("acceptableBlockTypes").GetValue<List<Item_Base>>().Add(repellentItem);

                var baseTex = new Texture2D(128, 128);
                baseTex.LoadImage(GetEmbeddedFileBytes("sprite.png"));
                Sprite spriteTexture(Color color)
                {
                    var sprite = Sprite.Create(new Texture2D(baseTex.width, baseTex.height, baseTex.format, false), new Rect(0, 0, baseTex.width, baseTex.height), new Vector2(0, 0), 1);
                    var texture = sprite.texture;
                    Func<float, float, float, float> edit = (v, s, b) => 1 - (1 - v * s) * (1 - b);
                    for (int x = 0; x < texture.width; x++)
                        for (int y = 0; y < texture.height; y++)
                        {
                            var c = baseTex.GetPixel(x, y);
                            var b = Mathf.Max(c.r * 2 - 1, 0);
                            var s = Mathf.Min(c.r * 2, 1);

                            if (c.a == 0)
                                texture.SetPixel(x, y, Color.clear);
                            else
                                texture.SetPixel(x, y, new Color(edit(color.r, s, b), edit(color.g, s, b), edit(color.b, s, b), c.a));
                        }
                    texture.Apply();
                    return sprite;
                };

                originalItem = ItemManager.GetItemByName("Plank");
                var newItem = originalItem.Clone(8765, "Garden_Sprite");
                newItem.settings_Inventory.LocalizationTerm = "";
                newItem.settings_Inventory.DisplayName = "Garden Sprite";
                newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to take interest in nearby plants.";
                Traverse.Create(newItem.settings_Inventory).Field("stackSize").SetValue(1);
                newItem.settings_Inventory.Sprite = spriteTexture(new Color(0.2f, 1, 0));
                Traverse.Create(newItem.settings_recipe).Field("blueprintItem").SetValue(repellentItem);
                spriteItems.Add(newItem.UniqueName, newItem);
                spriteTypes.Add(newItem.UniqueName, GetConstructor<GardenSprite>());

                newItem = spriteItems["Garden_Sprite"].Clone(8766, "Animal_Sprite");
                newItem.settings_Inventory.DisplayName = "Animal Sprite";
                newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to take interest in nearby animals.";
                newItem.settings_Inventory.Sprite = spriteTexture(new Color(1, 0, 1));
                spriteItems.Add(newItem.UniqueName, newItem);
                spriteTypes.Add(newItem.UniqueName, GetConstructor<AnimalSprite>());

                newItem = spriteItems["Garden_Sprite"].Clone(8767, "Fire_Sprite");
                newItem.settings_Inventory.DisplayName = "Fire Sprite";
                newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to take interest in nearby grills and smelters.";
                newItem.settings_Inventory.Sprite = spriteTexture(new Color(1, 0, 0));
                spriteItems.Add(newItem.UniqueName, newItem);
                spriteTypes.Add(newItem.UniqueName, GetConstructor<FireSprite>());

                newItem = spriteItems["Garden_Sprite"].Clone(8768, "Fire_Sprite_2");
                newItem.settings_Inventory.DisplayName = "Fire Sprite";
                newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to take interest in nearby cooking pots.";
                newItem.settings_Inventory.Sprite = spriteTexture(new Color(0.5f, 0, 0));
                spriteItems.Add(newItem.UniqueName, newItem);
                spriteTypes.Add(newItem.UniqueName, GetConstructor<FireSprite2>());

                newItem = spriteItems["Garden_Sprite"].Clone(8769, "Cleaner_Sprite");
                newItem.settings_Inventory.DisplayName = "Cleaner Sprite";
                newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to become irritated by nearby mess.";
                newItem.settings_Inventory.Sprite = spriteTexture(new Color(1, 1, 0));
                spriteItems.Add(newItem.UniqueName, newItem);
                spriteTypes.Add(newItem.UniqueName, GetConstructor<CleanerSprite>());

                newItem = spriteItems["Garden_Sprite"].Clone(8770, "Mechanic_Sprite");
                newItem.settings_Inventory.DisplayName = "Mechanic Sprite";
                newItem.settings_Inventory.Description = "A little glowing friend.\nIt seems to take interest in nearby refiners, engines and tanks";
                newItem.settings_Inventory.Sprite = spriteTexture(new Color(0, 0.5f, 1));
                spriteItems.Add(newItem.UniqueName, newItem);
                spriteTypes.Add(newItem.UniqueName, GetConstructor<MechanicSprite>());
            }

            if (!devMode)
            {
                modlistEntry.jsonmodinfo.isModPermanent = true;
                HMLLibrary.ModManagerPage.RefreshModState(modlistEntry);
            }

            if (!reload)
            {
                foreach (var item in spriteItems.Values)
                    RAPI.RegisterItem(item);
                RAPI.RegisterItem(repellentItem);
                foreach (var rand in Resources.FindObjectsOfTypeAll<SO_RandomDropper>())
                    if (rand.name.Contains("Dropper_FishingRod_Metal")) //csrun Debug.Log(Traverse.Create(Traverse.Create(Traverse.Create(FindObjectOfType<FishingRod>()).Field("fishingBaitHandler").GetValue()).Field("defaultDropper").GetValue()).Field("randomDropperAsset").GetValue());
                    {
                        var items = rand.randomizer.items.ToList();
                        items.Add(new RandomItem() { obj = spriteItems["Garden_Sprite"], weight = 1.5f, spawnChance = "" });
                        items.Add(new RandomItem() { obj = spriteItems["Animal_Sprite"], weight = 1.5f, spawnChance = "" });
                        items.Add(new RandomItem() { obj = spriteItems["Fire_Sprite"], weight = 1.5f, spawnChance = "" });
                        items.Add(new RandomItem() { obj = spriteItems["Fire_Sprite_2"], weight = 0.5f, spawnChance = "" });
                        items.Add(new RandomItem() { obj = spriteItems["Cleaner_Sprite"], weight = 1.5f, spawnChance = "" });
                        items.Add(new RandomItem() { obj = spriteItems["Mechanic_Sprite"], weight = 1f, spawnChance = "" });
                        rand.randomizer.items = items.ToArray();
                        var total = rand.randomizer.TotalWeight;
                        foreach (var item in rand.randomizer.items)
                            item.spawnChance = (item.weight / total * 100) + "%";
                    }
            }

            BlockCreator.RemoveBlockCallStack += RemoveBlock;

            harmony = new Harmony("com.aidanamite.BenevolentSprites");
            harmony.PatchAll();
            Log("Mod has been loaded!");
        }

        public void OnModUnload()
        {
            if (repellentItem)
            {
                harmony.UnpatchAll(harmony.Id);
                BlockCreator.RemoveBlockCallStack -= RemoveBlock;
                Log("Mod has been unloaded!");
            }
        }

        static void RemoveBlock(List<Block> blocks, Network_Player player)
        {
            foreach (var block in blocks)
            {
                if (!block) continue;
                if (block is Block_Foundation_ItemNet)
                    itemnets.Remove((Block_Foundation_ItemNet)block);
                if (block.GetComponent<BeeHive>())
                    beehives.Remove(block.GetComponent<BeeHive>());
                if (block.GetComponent<CookingTable_Recipe_UI>())
                    recipes.Remove(block.GetComponent<CookingTable_Recipe_UI>());
                if (block.GetComponent<CookingTable>())
                    tables.Remove(block.GetComponent<CookingTable>());
                if (block.GetComponent<Block_CookingStand>())
                    stands.Remove(block.GetComponent<Block_CookingStand>());
                tanks.RemoveAll((x) => x.Receiver.gameObject == block.gameObject || x.Tank.transform.IsChildOf(block.transform));
            }
        }

        public static HelperSprite CreateSprite(Storage_Small box, Slot item, uint SpriteIndex = 0)
        {
            if (!spriteTypes.ContainsKey(item.itemInstance.UniqueName))
                return null;
            HelperSprite newFire = (HelperSprite)spriteTypes[item.itemInstance.UniqueName].Invoke(new object[] { box, item, SpriteIndex });
            sprites.Add(newFire);
            if (Raft_Network.IsHost)
                new Message_Sprite_Create(newFire).Message.Broadcast();
            return newFire;
        }
        public static HelperSprite CreateSprite(Message_InitiateConnection message)
        {
            if (message.appBuildID == MessageType.Create)
            {
                var data = new Message_Sprite_Create(message);
                return CreateSprite(data.Box, data.Slot, data.SpriteIndex);
            }
            else if (message.appBuildID == MessageType.Recreate)
            {
                var data = new Message_Sprite_Recreate(message);
                var sprite = CreateSprite(data.Box, data.Slot, data.SpriteIndex);
                sprite.gameObject.transform.localPosition = data.Position;
                sprite.SetTarget(sprite.FindTarget(data.TargetIndex).transform, data.Offset);
                return sprite;
            }
            return null;
        }
        public static HelperSprite CreateSprite(string serial)
        {
            //Debug.Log("Restoring sprite from serial");
            var data = serial.Bytes();
            var sprite = CreateSprite(new Message_InitiateConnection(0, MessageType.Recreate, serial));
            sprite.holding.AddRange(data.Items(out int inc, 40));
            List<byte> extra = new List<byte>();
            for (int i = 40 + inc; i < data.Length; i++)
                extra.Add(data[i]);
            sprite.RestoreData(extra.ToArray());
            if (sprite.store.itemInstance.TryGetData(out var d))
                sprite.store.itemInstance.RemoveValue(dataKey);
            else
                sprite.store.itemInstance.exclusiveString = "";
            return sprite;
        }

        public void Update()
        {
            for (int i = sprites.Count - 1; i >= 0; i--)
                try
                {
                    if (sprites[i].IsDead)
                        sprites.RemoveAt(i);
                    else
                        sprites[i].Update(Time.deltaTime);
                }
                catch (Exception e)
                {
                    Debug.LogError(e);
                }
        }
        static NetworkChannel ModUtils_Channel = (NetworkChannel)MessageType.ChannelID;
        bool ModUtils_MessageRecieved(CSteamID steamID, NetworkChannel channel, Message message)
        {
            if (message.Type == MessageType.MessageID && message is Message_InitiateConnection)
            {
                if (gameLoaded)
                    ProcessMessage(message as Message_InitiateConnection);
                else
                    waiting.Add(message as Message_InitiateConnection);
                return true;
            }
            return false;
        }

        public static void ProcessMessage(Message_InitiateConnection msg) => ((Message_Sprite)MessageType.Contructor[msg.appBuildID].Invoke(new object[] { msg })).Use();

        public override void WorldEvent_OnPlayerConnected(CSteamID steamid, RGD_Settings_Character characterSettings)
        {
            if (Raft_Network.IsHost)
                foreach (var sprite in sprites)
                    new Message_Sprite_Recreate(sprite).Message.Send(steamid);
        }
        public override void WorldEvent_WorldLoaded()
        {
            if (Raft_Network.IsHost)
            {
                gameLoaded = true;
                foreach (var box in StorageManager.allStorages)
                {
                    var placed = new List<Slot>();
                    foreach (var slot in box.GetInventoryReference().allSlots)
                        if (slot.HasSprite() && placed.AddUniqueOnly(slot))
                        {
                            try
                            {
                                //Debug.Log("Sprite has " + slot.itemInstance.exclusiveString.Length + " chars of data");
                                if (!slot.itemInstance.TryGetData(out var data) && slot.itemInstance.exclusiveString != "")
                                {
                                    data.Add(dataKey, slot.itemInstance.exclusiveString);
                                    slot.itemInstance.SetData(data);
                                }
                                if (data.ContainsKey(dataKey))
                                    CreateSprite(data[dataKey]);
                                else
                                    CreateSprite(box, slot);
                            }
                            catch (Exception err)
                            {
                                Debug.LogError("Failed to create sprite in slot " + box.GetInventoryReference().allSlots.IndexOf(slot) + " of " + box.name + " (" + box.ObjectIndex + ")\n" + err);
                            }
                        }
                }
            }
        }

        [ConsoleCommand(name: "clearSpriteData", docs: "Clears any cache data left on sprites in the world")]
        public static string MyCommand(string[] args)
        {
            if (SceneManager.GetActiveScene().name != Raft_Network.GameSceneName)
                return "Can only be used in world";
            foreach (var s in RAPI.GetLocalPlayer().Inventory.allSlots)
                if (s.HasSprite())
                {
                    if (s.itemInstance.TryGetData(out var data))
                        s.itemInstance.RemoveValue(dataKey);
                    else
                        s.itemInstance.exclusiveString = "";
                }
            foreach (var b in StorageManager.allStorages)
                foreach (var s in b.GetInventoryReference().allSlots)
                    if (s.HasSprite())
                    {
                        if (s.itemInstance.TryGetData(out var data))
                            s.itemInstance.RemoveValue(dataKey);
                        else
                            s.itemInstance.exclusiveString = "";
                    }
            return "Sprite data cleared";
        }

        [ConsoleCommand(name: "getSpriteData", docs: "Usage: getSpriteData [index] - Returns a list of sprite indecies or returns details on a sprite with a specific index")]
        public static string MyCommand2(string[] args)
        {
            if (SceneManager.GetActiveScene().name != Raft_Network.GameSceneName)
                return "Can only be used in world";
            if (args.Length == 0)
                return sprites.Join(x => x == null ? "null" : $"{x.ObjectIndex} ({x.GetType().Name}) in {x.box?.buildableItem?.settings_Inventory.DisplayName}", "\n");
            if (!uint.TryParse(args[0], out var i))
                return $"Could not parse {args[0]} as a whole positive number";
            foreach (var s in sprites)
                if (s?.ObjectIndex == i)
                    return $"Type: {s.GetType().Name}\nStorage Box Type: {s.box?.buildableItem?.settings_Inventory.DisplayName}\nPosition: {s.gameObject?.transform.position}\nTarget Position: {s.TargetGlobal}\nTarget Object: {s.targetObject?.name}";
            return "";
        }

        public override void WorldEvent_WorldUnloaded()
        {
            gameLoaded = false;
            itemnets.Clear();
            beehives.Clear();
            recipes.Clear();
            tables.Clear();
            stands.Clear();
            tanks.Clear();
            CleanerSprite.fishNetCache.Clear();
        }

        void ExtraSettingsAPI_Load() => ExtraSettingsAPI_SettingsClose();
        void ExtraSettingsAPI_SettingsClose()
        {
            PlaySounds = ExtraSettingsAPI_GetCheckboxState("playSound");
            keepItem = ExtraSettingsAPI_GetComboboxSelectedIndex("leaveItem");
            ec_garden = ExtraSettingsAPI_GetCheckboxState("gardenCollect");
            ec_animal = ExtraSettingsAPI_GetCheckboxState("animalCollect");
            ec_animal2 = ExtraSettingsAPI_GetCheckboxState("animal2Collect");
            ec_animal3 = ExtraSettingsAPI_GetCheckboxState("animal3Collect");
            ec_fire = ExtraSettingsAPI_GetCheckboxState("fireCollect");
            ec_fire2 = ExtraSettingsAPI_GetCheckboxState("fire2Collect");
            ec_clean = ExtraSettingsAPI_GetCheckboxState("cleanCollect");
            spriteRange = Parse(ExtraSettingsAPI_GetInputValue("spriteRange"));
            gardenRange = Parse(ExtraSettingsAPI_GetInputValue("gardenRange"));
            animalRange = Parse(ExtraSettingsAPI_GetInputValue("animalRange"));
            fireRange = Parse(ExtraSettingsAPI_GetInputValue("fireRange"));
            fire2Range = Parse(ExtraSettingsAPI_GetInputValue("fire2Range"));
            cleanerRange = Parse(ExtraSettingsAPI_GetInputValue("cleanerRange"));
            mechanicRange = Parse(ExtraSettingsAPI_GetInputValue("mechanicRange"));
            repelRange = Parse(ExtraSettingsAPI_GetInputValue("repelRange"));
            repelRange *= repelRange;

            //Debug.Log($"{spriteRange} {repelRange}");
        }

        public static ConstructorInfo GetConstructor<T>() where T : HelperSprite => typeof(T).GetConstructor(new Type[] { typeof(Storage_Small), typeof(Slot), typeof(uint) });

        public bool ExtraSettingsAPI_GetCheckboxState(string SettingName) => false;
        public string ExtraSettingsAPI_GetInputValue(string SettingName) => "";
        public int ExtraSettingsAPI_GetComboboxSelectedIndex(string SettingName) => -1;


        static float Parse(string value)
        {
            if (string.IsNullOrWhiteSpace(value))
                return 1;
            if (value.Contains(",") && !value.Contains("."))
                value = value.Replace(',', '.');
            var c = CultureInfo.CurrentCulture;
            CultureInfo.CurrentCulture = CultureInfo.GetCultureInfoByIetfLanguageTag("en-NZ");
            Exception e = null;
            float r = 0;
            try
            {
                r = float.Parse(value);
            }
            catch (Exception e2)
            {
                e = e2;
            }
            CultureInfo.CurrentCulture = c;
            if (e != null)
                throw e;
            return r;
        }

        void ModUtils_ModLoaded(Mod mod)
        {
            if (mod.GetType().Name == "Arashi_RaftFishingExpansion")
                fishnets = Traverse.Create(mod).Field<IEnumerable<MonoBehaviour>>("activeFishingNets");
        }
        void ModUtils_ModUnloaded(Mod mod)
        {
            if (mod.GetType().Name == "Arashi_RaftFishingExpansion")
                fishnets = null;
        }
    }

    static class ExtentionMethods
    {
        static Dictionary<Slot, Storage_Small> refs = new Dictionary<Slot, Storage_Small>();
        static Dictionary<SO_ItemYield, List<Item_Base>> yieldCache = new Dictionary<SO_ItemYield, List<Item_Base>>();
        static FieldInfo pM = typeof(Cropplot).GetField("plantManager", ~BindingFlags.Default);
        public static PlantManager plantManager(this Cropplot plot) => (PlantManager)pM.GetValue(plot);

        public static Sprite GetReadable(this Sprite source) => Sprite.Create(source.texture.GetReadable(), source.rect, source.pivot, source.pixelsPerUnit);

        public static Texture2D GetReadable(this Texture2D source)
        {
            RenderTexture temp = RenderTexture.GetTemporary(source.width, source.height, 0, RenderTextureFormat.Default, RenderTextureReadWrite.Linear);
            Graphics.Blit(source, temp);
            RenderTexture prev = RenderTexture.active;
            RenderTexture.active = temp;
            Texture2D texture = new Texture2D(source.width, source.height);
            texture.ReadPixels(new Rect(0, 0, temp.width, temp.height), 0, 0);
            texture.Apply();
            RenderTexture.active = prev;
            RenderTexture.ReleaseTemporary(temp);
            return texture;
        }
        public static Sprite CreateEmpty(this Sprite sprite)
        {
            return Sprite.Create(new Texture2D(sprite.texture.width, sprite.texture.height, TextureFormat.RGBA32, false), sprite.rect, sprite.pivot, sprite.pixelsPerUnit);
        }
        public static Item_Base Clone(this Item_Base source, int uniqueIndex, string uniqueName)
        {
            Item_Base item = ScriptableObject.CreateInstance<Item_Base>();
            item.Initialize(uniqueIndex, uniqueName, source.MaxUses);
            item.settings_buildable = source.settings_buildable.Clone();
            item.settings_consumeable = source.settings_consumeable.Clone();
            item.settings_cookable = source.settings_cookable.Clone();
            item.settings_equipment = source.settings_equipment.Clone();
            item.settings_Inventory = source.settings_Inventory.Clone();
            item.settings_recipe = source.settings_recipe.Clone();
            item.settings_usable = source.settings_usable.Clone();
            return item;
        }

        public static void SetRecipe(this ItemInstance_Recipe item, CostMultiple[] cost, int amountToCraft = 1)
        {
            Traverse.Create(item).Field("amountToCraft").SetValue(amountToCraft);
            item.NewCost = cost;
        }

        public static bool HasSprite(this Slot slot)
        {
            return slot.HasValidItemInstance() && slot.itemInstance.UniqueName.IsSprite();
        }

        public static bool IsSprite(this string uniqueName) => BenevolentSprites.spriteItems.ContainsKey(uniqueName);
        public static bool IsSprite(this Item_Base item) => item.UniqueName.IsSprite();

        public static HelperSprite GetSprite(this Slot slot)
        {
            foreach (var sprite in BenevolentSprites.sprites)
                if (sprite.store == slot)
                    return sprite;
            return null;
        }

        public static int Missing(this Fuel fuel) => fuel == null ? 0 : fuel.MaxFuel - fuel.GetFuelCount();

        public static void ForceStart(this CookingTable table, SO_CookingTable_Recipe recipe)
        {
            if (recipe == null)
                return;
            table.CurrentRecipe = recipe;
            table.CookTimer = 0f;
            table.Portions = 0;
            table.StartCoroutine(Traverse.Create(table).Method("SetAnimationState", new object[] { true, Traverse.Create(table).Field("startAnimDelay").GetValue<float>() }).GetValue<IEnumerator>());
            if (table is CookingTable_Pot)
                ((CookingTable_Pot)table).Fuel.StartBurning();
        }

        public static void Remove(this CookingTable table, int amount)
        {
            if (amount <= 0)
                return;
            if (table.Portions < amount)
                table.Portions = 0;
            else
                table.Portions -= (uint)amount;
            if (table.Portions == 0)
            {
                table.CurrentRecipe = null;
                Traverse.Create(table).Field("gooModel").GetValue<GameObject>().SetActive(false);
                Traverse.Create(table).Field("finishedModel").GetValue<GameObject>().SetActive(false);
            }
        }

        public static void Clear(this PickupChanneling pickup)
        {
            while (pickup.ItemsRemaining != 0)
                pickup.YieldHandler.RemoveYield();
            pickup.pickupItem.networkID.OnPickedUp?.Invoke();
        }

        public static Storage_Small GetStorage(this Slot slot)
        {
            if (refs.TryGetValue(slot, out var box) && box != null)
                return box;
            var inv = Traverse.Create(slot).Field("inventory").GetValue<Inventory>();
            foreach (var storage in StorageManager.allStorages)
                if (storage.GetInventoryReference() == inv)
                {
                    refs[slot] = storage;
                    return storage;
                }
            return null;
        }

        public static void Close(this Storage_Small box)
        {
            new Message_Storage_Close(Messages.StorageManager_Close, RAPI.GetLocalPlayer().StorageManager, box).Broadcast(NetworkChannel.Channel_Game);
        }

        public static bool Contains(this List<ItemInstance> items, Item_Base item)
        {
            foreach (var i in items)
                if (i.Valid && i.baseItem == item)
                    return true;
            return false;
        }

        public static int GetCount(this List<ItemInstance> items, Item_Base item)
        {
            var c = 0;
            foreach (var i in items)
                if (i.baseItem == item)
                    c += i.Amount;
            return c;
        }

        public static int GetCount(this List<ItemInstance> items, CostMultiple item, bool leaveOneItem = false)
        {
            var c = 0;
            var leave = new List<Item_Base>();
            foreach (var i in items)
                if (item.ContainsItem(i.baseItem))
                {
                    if (leaveOneItem && leave.AddUniqueOnly(i.baseItem))
                        c += i.Amount - 1;
                    else
                        c += i.Amount;
                }
            return c;
        }

        public static void Remove(this List<ItemInstance> items, Item_Base item, int Count)
        {
            for (int i = items.Count - 1; i >= 0; i--)
                if (items[i].baseItem.UniqueIndex == item.UniqueIndex)
                {
                    if (items[i].Amount > Count)
                    {
                        items[i].Amount -= Count;
                        return;
                    }
                    else if (items[i].Valid)
                    {
                        Count -= items[i].Amount;
                        items.RemoveAt(i);
                    }
                    else
                        items.RemoveAt(i);
                }
        }
        public static void RemoveUses(this List<ItemInstance> items, Item_Base item, int Count)
        {
            if (item.MaxUses <= 1)
                items.Remove(item, Count);
            else
                for (int i = items.Count - 1; i >= 0; i--)
                    if (items[i].baseItem.UniqueIndex == item.UniqueIndex)
                    {
                        if (items[i].Uses > Count)
                        {
                            items[i].Uses -= Count;
                            return;
                        }
                        else if (!items[i].Valid)
                            items.RemoveAt(i);
                        else if (items[i].UsesInStack <= Count)
                        {
                            Count -= items[i].UsesInStack;
                            if (item.settings_consumeable.ItemAfterUse?.item != null)
                                for (int j = 0; j < items[i].Amount; j++)
                                    items.Add(item.settings_consumeable.ItemAfterUse);
                            items.RemoveAt(i);
                        }
                        else
                        {
                            while (Count > items[i].Uses)
                            {
                                Count -= items[i].Uses;
                                items[i].Amount--;
                                if (item.settings_consumeable.ItemAfterUse?.item != null)
                                    items.Add(item.settings_consumeable.ItemAfterUse);
                                items[i].Uses = item.MaxUses;
                            }
                            items[i].Uses -= Count;
                            return;
                        }
                    }
        }

        public static CookingTable_Recipe_UI FindRecipe(this CookingTable table, List<ItemInstance> items, bool leaveOneItem = false)
        {
            CookingTable_Recipe_UI nearest = null;
            var min = float.MaxValue;
            foreach (var recipe in BenevolentSprites.recipes)
                if (recipe && recipe.Recipe && recipe.Recipe.RecipeType == table.cookingType)
                {
                    var dist = (recipe.transform.position - table.transform.position).magnitude;
                    if (dist < min && recipe.Recipe.RecipeCost.CanCraftFrom(items,leaveOneItem))
                    {
                        min = dist;
                        nearest = recipe;
                    }
                }
            if (min > 2)
                return null;
            return nearest;
        }

        public static bool CanCraftFrom(this CostMultiple[] costs, List<ItemInstance> items, bool leaveOneItem = false)
        {
            foreach (CostMultiple cost in costs)
                if (items.GetCount(cost,leaveOneItem) < cost.amount)
                    return false;
            return true;
        }

        public static List<ItemInstance> TakeItems(this Inventory inventory, CostMultiple[] costs)
        {
            var items = new List<ItemInstance>();
            foreach (CostMultiple cost in costs)
            {
                var c = cost.amount;
                foreach (var slot in inventory.allSlots)
                    if (slot.HasValidItemInstance() && cost.ContainsItem(slot.itemInstance.baseItem))
                    {
                        if (slot.itemInstance.Amount <= c)
                        {
                            c -= slot.itemInstance.Amount;
                            items.Add(slot.itemInstance.Clone());
                            slot.SetItem(null);
                        }
                        else
                        {
                            items.Add(new Cost(slot.itemInstance.baseItem, c));
                            slot.itemInstance.Amount -= c;
                            c = 0;
                        }
                        slot.RefreshComponents();
                        if (c == 0)
                            break;
                    }
            }
            return items;
        }
        public static List<ItemInstance> TakeItems(this Inventory inventory, Item_Base item, int count, bool leaveOneItem = false)
        {
            var items = new List<ItemInstance>();
            foreach (var slot in inventory.allSlots)
                if (slot.HasValidItemInstance() && slot.itemInstance.baseItem.UniqueIndex == item.UniqueIndex)
                {
                    if (slot.itemInstance.Amount > count)
                    {
                        items.Add(new ItemInstance(item, count, item.MaxUses));
                        slot.itemInstance.Amount -= count;
                        slot.RefreshComponents();
                        break;
                    }
                    else
                    {
                        if (leaveOneItem)
                        {
                            leaveOneItem = false;
                            count -= slot.itemInstance.Amount - 1;
                            items.Add(new ItemInstance(item, slot.itemInstance.Amount - 1, item.MaxUses));
                            slot.itemInstance.Amount = 1;
                            slot.RefreshComponents();
                        }
                        else
                        {
                            count -= slot.itemInstance.Amount;
                            items.Add(slot.itemInstance);
                            slot.itemInstance = null;
                            slot.RefreshComponents();
                        }
                    }
                }
            return items;
        }
        public static List<ItemInstance> TakeItemUses(this Inventory inventory, Item_Base item, int count, bool leaveOneItem = false)
        {
            var items = new List<ItemInstance>();
            if (item.MaxUses <= 1)
                return inventory.TakeItems(item, count, leaveOneItem);
            foreach (var slot in inventory.allSlots)
                if (slot.HasValidItemInstance() && slot.itemInstance.baseItem.UniqueIndex == item.UniqueIndex)
                {
                    if (slot.itemInstance.Uses > count)
                    {
                        if (slot.itemInstance.Amount > 1)
                        {
                            items.Add(new ItemInstance(item, 1, slot.itemInstance.Uses));
                            slot.itemInstance.Amount--;
                            slot.itemInstance.Uses = item.MaxUses;
                        } else
                        {
                            if (leaveOneItem)
                                leaveOneItem = false;
                            else
                            {
                                items.Add(slot.itemInstance);
                                slot.itemInstance = null;
                            }
                        }
                        slot.RefreshComponents();
                        break;
                    } else if (slot.itemInstance.Amount > 1 && item.MaxUses > count)
                    {
                        items.Add(new ItemInstance(item, 1, item.MaxUses));
                        slot.itemInstance.Amount--;
                        slot.RefreshComponents();
                        break;
                    }
                    else if (slot.itemInstance.UsesInStack <= count)
                    {
                        if (leaveOneItem)
                        {
                            leaveOneItem = false;
                            if (slot.itemInstance.Amount > 1)
                            {
                                count -= slot.itemInstance.UsesInStack - slot.itemInstance.Uses;
                                items.Add(new ItemInstance(slot.itemInstance.baseItem, slot.itemInstance.Amount - 1, slot.itemInstance.baseItem.MaxUses));
                                slot.itemInstance.Amount = 1;
                                slot.RefreshComponents();
                            }
                        }
                        else
                        {
                            count -= slot.itemInstance.UsesInStack;
                            items.Add(slot.itemInstance);
                            slot.itemInstance = null;
                            slot.RefreshComponents();
                        }
                    }
                    else
                    {
                        if (!leaveOneItem && count % item.MaxUses <= slot.itemInstance.Uses)
                        {
                            var c = Mathf.CeilToInt((float)count / item.MaxUses);
                            slot.itemInstance.Amount -= c;
                            items.Add(new ItemInstance(item, c, slot.itemInstance.Uses));
                            slot.itemInstance.Uses = item.MaxUses;
                        }
                        else
                        {
                            var c = Mathf.CeilToInt((float)count / item.MaxUses);
                            slot.itemInstance.Amount -= c;
                            items.Add(new ItemInstance(item, c, item.MaxUses));
                        }
                        slot.RefreshComponents();
                        break;
                    }
                }
            return items;
        }

        public static void Remove(this List<ItemInstance> items, CostMultiple[] costs)
        {
            foreach (CostMultiple cost in costs)
            {
                var c = cost.amount;
                for (int i = items.Count - 1; i >= 0; i--)
                    if (items[i].Valid && cost.ContainsItem(items[i].baseItem))
                    {
                        if (items[i].Amount <= c)
                        {
                            c -= items[i].Amount;
                            items.RemoveAt(i);
                        }
                        else
                        {
                            items[i].Amount -= c;
                            c = 0;
                        }
                        if (c == 0)
                            break;
                    }
            }
        }

        public static List<ItemInstance> GetAllItems(this Inventory inventory)
        {
            var items = new List<ItemInstance>();
            foreach (var slot in inventory.allSlots)
                if (slot.HasValidItemInstance())
                    items.Add(slot.itemInstance);
            return items;
        }

        public static List<ItemInstance> GetAllItems(this PickupItem pickup)
        {
            var items = new List<ItemInstance>();
            if (pickup.yieldHandler?.Yield?.Count > 0)
            {
                items.AddAll(pickup.yieldHandler.Yield);
                if (pickup.dropper)
                    for (int i = 0; i < pickup.yieldHandler.Yield.Count; i++)
                    items.AddAll(pickup.dropper.GetRandomItems());
            }
            else if (pickup.dropper)
                items.AddAll(pickup.dropper.GetRandomItems());
            if (pickup.itemInstance != null && pickup.itemInstance.Valid)
                items.Add(pickup.itemInstance);
            if (pickup.specificPickups != null)
            {
                var tempObj = new GameObject();
                Patch_InventoryOverrides.ignore = tempObj;
                tempObj.SetActive(false);
                var tempInv = tempObj.AddComponent<PlayerInventory>();
                tempInv.hotslotCount = 1;
                tempInv.hotbar = tempObj.AddComponent<Hotbar>();
                Traverse.Create(tempInv).Field("inventoryPickup").SetValue(tempObj.AddComponent<InventoryPickup>());
                var tempTxt = new GameObject().AddComponent<Text>();
                for (int i = 0; i < 20; i++)
                {
                    var s = new GameObject().AddComponent<Slot>();
                    s.rectTransform = s.gameObject.AddComponent<RectTransform>();
                    s.active = true;
                    s.textComponent = tempTxt;
                    tempInv.allSlots.Add(s);
                }
                foreach (var specificPickup in pickup.specificPickups)
                {
                    specificPickup.PickupSpecific(tempInv);
                    items.AddRange(tempInv.GetAllItems());
                    foreach (var slot in tempInv.allSlots)
                        slot.SetItem(null);
                }
                foreach (var slot in tempInv.allSlots)
                    Object.Destroy(slot);
                Object.Destroy(tempTxt.gameObject);
                Object.Destroy(tempObj);
            }
            return items;
        }

        public static List<Item_Base> GetAllPossible(this PickupItem pickup)
        {
            var loot = new List<Item_Base>();
            if (pickup.yieldHandler && pickup.yieldHandler.yieldAsset)
                foreach (var item in pickup.yieldHandler.yieldAsset.GetAllPossible())
                    loot.AddUniqueOnly(item);
            if (pickup.dropper)
                foreach (var item in Traverse.Create(pickup.dropper).Field("randomDropperAsset").GetValue<SO_RandomDropper>().randomizer.items)
                    if (item.obj)
                        loot.AddUniqueOnly((Item_Base)item.obj);
            if (pickup.itemInstance != null)
                loot.AddUniqueOnly(pickup.itemInstance.baseItem);
            return loot;
        }

        public static List<Item_Base> GetAllPossible(this SO_ItemYield yield)
        {
            if (yieldCache.ContainsKey(yield))
                return yieldCache[yield];
            var loot = new List<Item_Base>();
            foreach (var item in yield.yieldAssets)
                loot.AddUniqueOnly(item.item);
            return loot;
        }

        public static void AddAll(this List<ItemInstance> items, IEnumerable<Cost> newItems)
        {
            if (newItems != null)
                foreach (var cost in newItems)
                    if (cost != null)
                        items.Add(new ItemInstance(cost.item, cost.amount, cost.item.MaxUses));
        }
        public static void AddAll(this List<ItemInstance> items, IEnumerable<Item_Base> newItems)
        {
            if (newItems != null)
                foreach (var item in newItems)
                    if (item != null)
                        items.Add(new ItemInstance(item, 1, item.MaxUses));
        }
        public static void AddAll(this List<ItemInstance> items, IEnumerable<ItemInstance> newItems)
        {
            if (newItems != null)
                foreach (var item in newItems)
                    if (item != null)
                        items.Add(item);
        }
        public static void Add(this List<ItemInstance> items, Cost cost)
        {
            if (cost != null)
                items.Add(new ItemInstance(cost.item, cost.amount, cost.item.MaxUses));
        }
        public static void Add(this List<ItemInstance> items, Item_Base item)
        {
            if (item)
                items.Add(new ItemInstance(item, 1, item.MaxUses));
        }
        public static void Remove(this PickupItem_Networked pickup)
        {
            if (pickup.stopTrackUseRPC)
            {
                PickupObjectManager.RemovePickupItemNetwork(pickup, new CSteamID(0));
            }
            else
            {
                PickupObjectManager.RemovePickupItem(pickup, new CSteamID(0));
            }
        }
        public static Item_Base FindItem(this Inventory inventory, Block_CookingStand stand, out List<CookingSlot> slots, bool leaveOneItem = false)
        {
            slots = null;
            var leave = new List<Item_Base>();
            foreach (var s in inventory.allSlots)
                if (s.HasValidItemInstance())
                {
                    if (leaveOneItem && leave.AddUniqueOnly(s.itemInstance.baseItem) && s.itemInstance.Amount == 1)
                        continue;
                    slots = stand.GetCookingSlotsForItem(s.itemInstance.baseItem)?.ToList();
                    if (slots != null)
                        return s.itemInstance.baseItem;
                }
            return null;
        }

        public static bool IsRepelled(this Transform t)
        {
            foreach (var g in SpriteRepellent.repellents)
                if ((t.position - g.transform.position).sqrMagnitude < BenevolentSprites.RepelRange)
                    return true;
            return false;
        }
        public static bool IsRepelled(this Transform t, Vector3 off)
        {
            foreach (var g in SpriteRepellent.repellents)
                if ((t.TransformPoint(off) - g.transform.position).sqrMagnitude < BenevolentSprites.RepelRange)
                    return true;
            return false;
        }

        public static string String(this byte[] bytes, int length = -1, int offset = 0)
        {
            if (bytes.Length % 2 == 1)
            {
                var n = new byte[bytes.Length + 1];
                bytes.CopyTo(n, 0);
                bytes = n;
            }
            string str = "";
            if (length == -1)
                length = (bytes.Length - offset) / 2;
            while (str.Length < length)
            {
                str += BitConverter.ToChar(bytes, offset + str.Length * 2);
            }
            return str;

        }
        public static string String(this List<byte> bytes) => bytes.ToArray().String();
        public static byte[] Bytes(this string str)
        {
            var data = new List<byte>();
            foreach (char chr in str)
                data.AddRange(BitConverter.GetBytes(chr));
            return data.ToArray();
        }
        public static int Integer(this byte[] bytes, int offset = 0) => BitConverter.ToInt32(bytes, offset);
        public static uint UInteger(this byte[] bytes, int offset = 0) => BitConverter.ToUInt32(bytes, offset);
        public static float Float(this byte[] bytes, int offset = 0) => BitConverter.ToSingle(bytes, offset);
        public static Vector3 Vector3(this byte[] bytes, int offset = 0) => new Vector3(bytes.Float(offset), bytes.Float(offset + 4), bytes.Float(offset + 8));
        public static ItemInstance Item(this byte[] bytes, out int size, int offset = 0)
        {
            var stringSize = bytes.Integer(offset + 12);
            size = stringSize / 2 + 16;
            return new ItemInstance(ItemManager.GetItemByIndex(bytes.Integer(offset)), bytes.Integer(offset + 4), bytes.Integer(offset + 8), bytes.String(stringSize, offset + 16));
        }
        public static List<ItemInstance> Items(this byte[] bytes, out int size, int offset = 0)
        {
            var items = new List<ItemInstance>();
            var count = bytes.Integer(offset);
            size = 4;
            while (items.Count < count)
            {
                items.Add(bytes.Item(out int inc, offset + size));
                size += inc;
            }
            return items;
        }
        public static CookingSlotTargets CookingSlotTargets(this byte[] bytes, int offset = 0)
        {
            var u = bytes.UInteger(offset);
            var l = new List<int>();
            var c = bytes.Integer(offset + 4);
            for (int i = 0; i < c; i++)
                l.Add(bytes.Integer(offset + 8 + i * 4));
            return new CookingSlotTargets(u, 0) { slotInds = l.ToArray() };
        }
        public static byte[] Bytes(this int value) => BitConverter.GetBytes(value);
        public static byte[] Bytes(this uint value) => BitConverter.GetBytes(value);
        public static byte[] Bytes(this float value) => BitConverter.GetBytes(value);
        public static byte[] Bytes(this Vector3 value)
        {
            var data = new byte[12];
            value.x.Bytes().CopyTo(data, 0);
            value.y.Bytes().CopyTo(data, 4);
            value.z.Bytes().CopyTo(data, 8);
            return data;
        }
        public static byte[] Bytes(this ItemInstance value)
        {
            var data = new List<byte>();
            data.AddRange(value.baseItem.UniqueIndex.Bytes());
            data.AddRange(value.Amount.Bytes());
            data.AddRange(value.Uses.Bytes());
            data.AddRange(value.exclusiveString.Length.Bytes());
            data.AddRange(value.exclusiveString.Bytes());
            return data.ToArray();
        }
        public static byte[] Bytes(this IEnumerable<ItemInstance> values)
        {
            var data = new List<byte>();
            int count = 0;
            foreach (var item in values)
            {
                data.AddRange(item.Bytes());
                count++;
            }
            data.InsertRange(0, count.Bytes());
            return data.ToArray();
        }
        public static byte[] Bytes(this CookingSlotTargets value)
        {
            var data = new List<byte>();
            data.AddRange(value.ObjectIndex.Bytes());
            data.AddRange(value.slotInds.Length.Bytes());
            foreach (var i in value.slotInds)
                data.AddRange(i.Bytes());
            return data.ToArray();
        }

        public static void Broadcast(this Message message, NetworkChannel channel = (NetworkChannel)MessageType.ChannelID) => ComponentManager<Raft_Network>.Value.RPC(message, Target.Other, EP2PSend.k_EP2PSendReliable, channel);
        public static void Send(this Message message, CSteamID steamID) => ComponentManager<Raft_Network>.Value.SendP2P(steamID, message, EP2PSend.k_EP2PSendReliable, (NetworkChannel)MessageType.ChannelID);

        public static void SetValue(this ItemInstance item, string valueName, string value)
        {
            int pos = 0;
            var data = item.exclusiveString.Bytes();
            var newData = new List<byte>(data);
            while (pos < data.Length)
            {
                var l = data.Integer(pos);
                var name = data.String(l, pos + 4);
                pos += 4 + name.Length * 2;
                l = data.Integer(pos);
                var oldValue = data.String(l, pos + 4);
                if (name == valueName)
                {
                    newData.RemoveRange(pos, 4 + oldValue.Length * 2);
                    newData.InsertRange(pos, value.Bytes());
                    newData.InsertRange(pos, value.Length.Bytes());
                    break;
                }
                pos += 4 + oldValue.Length * 2;
            }
            if (pos >= data.Length)
            {
                newData.AddRange(valueName.Length.Bytes());
                newData.AddRange(valueName.Bytes());
                newData.AddRange(value.Length.Bytes());
                newData.AddRange(value.Bytes());
            }
            //Debug.Log("Data changed from " + (item.exclusiveString.Length * 2) + " to " + newData.Count);
            item.exclusiveString = newData.String();
        }

        public static string GetValue(this ItemInstance item, string valueName)
        {
            int pos = 0;
            var data = item.exclusiveString.Bytes();
            while (pos < data.Length)
            {
                var l = data.Integer(pos);
                var name = data.String(l, pos + 4);
                pos += 4 + name.Length * 2;
                l = data.Integer(pos);
                var value = data.String(l, pos + 4);
                pos += 4 + value.Length * 2;
                if (name == valueName)
                    return value;
            }
            throw new MissingFieldException("No value \"" + valueName + "\" was found on the ItemInstance");
        }

        public static bool RemoveValue(this ItemInstance item, string valueName)
        {
            int pos = 0;
            var data = item.exclusiveString.Bytes();
            while (pos < data.Length)
            {
                var l = data.Integer(pos);
                var name = data.String(l, pos + 4);
                var offset = 4 + name.Length * 2;
                l = data.Integer(pos + offset);
                var value = data.String(l, pos + offset + 4);
                offset += 4 + value.Length * 2;
                if (name == valueName)
                {
                    var newData = new List<byte>(data);
                    newData.RemoveRange(pos, offset);
                    item.exclusiveString = newData.String();
                    return true;
                }
                pos += offset;
            }
            return false;
        }

        public static Dictionary<string, string> GetData(this ItemInstance item)
        {
            int pos = 0;
            var data = item.exclusiveString.Bytes();
            var d = new Dictionary<string, string>();
            while (pos < data.Length)
            {
                var l = data.Integer(pos);
                var name = data.String(l, pos + 4);
                pos += 4 + name.Length * 2;
                l = data.Integer(pos);
                var value = data.String(l, pos + 4);
                pos += 4 + value.Length * 2;
                d.Add(name, value);
            }
            return d;
        }

        public static bool TryGetData(this ItemInstance item, out Dictionary<string, string> values)
        {
            try
            {
                values = item.GetData();
                return true;
            }
            catch
            {
                values = new Dictionary<string, string>();
                return false;
            }
        }

        public static void SetData(this ItemInstance item, Dictionary<string, string> values)
        {
            var data = new List<byte>();
            foreach (var pair in values)
            {
                data.AddRange(pair.Key.Length.Bytes());
                data.AddRange(pair.Key.Bytes());
                data.AddRange(pair.Value.Length.Bytes());
                data.AddRange(pair.Value.Bytes());
            }
            item.exclusiveString = data.String();
        }

        public static int IndexOf<T>(this T[] t, T value)
        {
            for (int i = 0; i < t.Length; i++)
                if (t[i].Equals(value))
                    return i;
            return -1;
        }

        public static bool Exists<T1, T2>(this IDictionary<T1, T2> pairs, Func<T1, T2, bool> condition)
        {
            foreach (var pair in pairs)
                if (condition(pair.Key, pair.Value))
                    return true;
            return false;
        }

        public static List<T> FindAll<T>(this object obj)
        {
            var t = obj.GetType();
            var l = new List<T>();
            do
            {
                foreach (var f in t.GetFields((BindingFlags)(-1)))
                    if (!f.IsStatic && (f.FieldType == typeof(T) || f.FieldType.IsSubclassOf(typeof(T))))
                        l.Add((T)f.GetValue(obj));
                t = t.BaseType;
            } while (t != typeof(object));
            return l;
        }
        static List<string> warned = new List<string>();
        public static int FuelValue(this Tank tank, Item_Base item)
        {
            SO_FuelValue v = null;
            if (tank && item)
            {
                v = LiquidFuelManager.GetFilteredFuelValueSoFromItem(item, tank.tankFiltrationType);
                if (v == null && warned.AddUniqueOnly($"{tank.tankFiltrationType} has no value for {item.UniqueName}"))
                    Debug.LogError($"The tank type {tank.tankFiltrationType} has no value for {item.UniqueName}");
            }
            return v == null ? int.MaxValue : v.fuelValueOfType;
        }
        public static Y Join<X, Y>(this IEnumerable<X> colleciton, Func<X, Y> converter, Func<Y, Y, Y> joiner)
        {
            var c = default(Y);
            foreach (var v in colleciton)
                c = joiner(c, converter(v));
            return c;
        }
    }

    public class SpriteRepellent : MonoBehaviour
    {
        public static List<SpriteRepellent> repellents = new List<SpriteRepellent>();
        public void OnBlockPlaced() => repellents.Add(this);
        public void OnDestroy()
        {
            if (repellents.Contains(this))
                repellents.Remove(this);
        }
    }

    public class HelperSprite
    {
        internal GameObject gameObject;
        internal Slot store;
        internal Item_Base item;
        public List<ItemInstance> holding;
        const float acceleration = 2f;
        const float maxVelocity = 10f;
        Vector3 velocity;
        internal Transform targetObject;
        public Vector3 targetPosition;
        Vector3 randomAccel;
        Vector3 targetRand;
        float time;
        internal bool dying;
        public uint ObjectIndex { private set; get; }
        internal Storage_Small box => store.GetStorage();
        public virtual float MaxDistance => box.GetInventoryReference().GetSlotCount() * BenevolentSprites.SpriteRange;
        public bool IsDead => gameObject == null;
        public Vector3 Target => targetObject == null ? targetPosition : gameObject.transform.parent.InverseTransformPoint(targetObject.TransformPoint(targetPosition));
        public Vector3 TargetGlobal => gameObject.transform.parent.TransformPoint(Target);
        public float DistanceFromTarget => (Target - gameObject.transform.localPosition).magnitude;
        public float SqrDistanceFromTarget => (Target - gameObject.transform.localPosition).sqrMagnitude;
        public const float interactDistance = 0.2f;
        public const float sqrInteractDistance = interactDistance * interactDistance;
        public HelperSprite(Storage_Small container, Slot slot, Color color, uint objectIndex = 0)
        {
            gameObject = Object.Instantiate(BenevolentSprites.FirePrefab, GameManager.Singleton.lockedPivot, false);
            if (objectIndex == 0)
                objectIndex = SaveAndLoad.GetUniqueObjectIndex();
            ObjectIndex = objectIndex;
            store = slot;
            item = slot.itemInstance.baseItem;
            gameObject.name = "sprite";
            gameObject.transform.position = container.transform.position;
            gameObject.transform.localScale = Vector3.one / 2;
            foreach (var p in gameObject.GetComponentsInChildren<ParticleSystem>())
            {
                var s = p.colorBySpeed;
                s.enabled = false;
                var l = p.colorOverLifetime;
                l.enabled = true;
                l.color = new ParticleSystem.MinMaxGradient(color);
                var m = p.main;
                m.startColor = new ParticleSystem.MinMaxGradient(Color.white);
            }
            Light glow = gameObject.AddComponent<Light>();
            glow.color = color;
            glow.intensity = 1;
            glow.range = 2;
            glow.enabled = true;
            gameObject.SetActive(true);
            SetTarget(container.transform, Vector3.up);
            randomAccel = Vector3.zero;
            dying = false;
            holding = new List<ItemInstance>();
        }
        public void SetTarget(Transform target, Vector3 position)
        {
            targetObject = target;
            targetPosition = position;
        }
        public void SetTargetNetwork(MonoBehaviour_ID target, Vector3 position)
        {
            if (target == null)
                return;
            SetTarget(target.transform, position);
            if (Raft_Network.IsHost)
                new Message_Sprite_SetTarget(this, target, position).Message.Broadcast();
        }

        public void Update(float t)
        {
            if (Raft_Network.IsHost && (!box || store?.itemInstance?.baseItem != item))
                Kill();
            time += t;
            if (time > 0.2)
            {
                targetRand = new Vector3(Random.Range(-1f, 1f), Random.Range(-1f, 1f), Random.Range(-1f, 1f));
                time -= 0.2f;
            }
            randomAccel = Vector3.Lerp(randomAccel, targetRand, t / 2);
            Vector3 dir = Target + randomAccel - gameObject.transform.localPosition;
            if (!dying)
                velocity += dir.normalized * acceleration * t;
            velocity *= Mathf.Pow(0.3f, t);
            velocity.Clamp(0, maxVelocity);
            gameObject.transform.localPosition += velocity * t;
            AI();
        }

        public virtual void Kill()
        {
            if (!dying)
            {
                if (Raft_Network.IsHost)
                    new Message_Sprite_Kill(this).Message.Broadcast();
                CoroutineManager.Singleton.StartCoroutine(Death());
            }
        }

        IEnumerator Death()
        {
            dying = true;
            float timePassed = 0;
            Light light = gameObject.GetComponent<Light>();
            foreach (var item in holding)
                Helper.DropItem(item, gameObject.transform.position, Vector3.down, true);
            while (timePassed < 0.75)
            {
                timePassed += Time.deltaTime / 2;
                float strength = Mathf.Max(Mathf.Sin(timePassed * Mathf.PI) * 3, 0);
                light.intensity = strength;
                light.range = strength * 2;
                yield return new WaitForEndOfFrame();
            }
            Destroy();
            yield break;
        }

        public void Destroy() => Object.Destroy(gameObject);

        void AI()
        {
            if (!Raft_Network.IsHost || dying)
                return;
            if (tryInteract())
            {
                MonoBehaviour_ID target = null;
                Vector3 targetOffset = Vector3.zero;
                if (holding.Count == 0 && targetObject == box.transform)
                    pickTarget(out target, out targetOffset);
                if (target == null)
                {
                    target = box;
                    if (holding.Count == 0)
                        targetOffset = Vector3.up;
                    else
                        targetOffset = Vector3.up * 0.2f;
                }
                if ((target == null ? null : target.transform) != targetObject || targetOffset != targetPosition)
                    SetTargetNetwork(target, targetOffset);
            }
        }

        internal bool tryDepositHeld()
        {
            if (targetObject == box.transform && !box.IsOpen && SqrDistanceFromTarget <= sqrInteractDistance)
            {
                bool added = false;
                for (int i = holding.Count - 1; i >= 0; i--)
                {
                    int pre = holding[i].Amount;
                    box.GetInventoryReference().AddItem(holding[i], false);
                    if (pre != holding[i].Amount)
                        added = true;
                    if (holding[i].Amount == 0)
                        holding.RemoveAt(i);
                }
                if (added)
                {
                    box.Close();
                    if (BenevolentSprites.PlaySounds)
                    {
                        var eventRef = Traverse.Create(ComponentManager<SoundManager>.Value).Field("eventRef_UI_MoveItem").GetValue<string>();
                        var msg = new Message_SoundManager_PlayOneShot(Messages.SoundManager_PlayOneShot, ComponentManager<Raft_Network>.Value.NetworkIDManager, ComponentManager<SoundManager>.Value.ObjectIndex, eventRef, box.transform.position);
                        msg.Broadcast();
                        FMODUnity.RuntimeManager.PlayOneShot(eventRef, msg.Position);
                    }
                }
            }
            return holding.Count == 0;
        }

        internal virtual bool tryInteract() => true;

        public virtual void RestoreData(byte[] data) { }
        public virtual byte[] GenerateData() { return new byte[0]; }

        internal virtual void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset) { target = box; targetOffset = Vector3.up; }

        public virtual MonoBehaviour_ID FindTarget(uint objectIndex)
        {
            foreach (var mono in Object.FindObjectsOfType<MonoBehaviour_ID>())
                if (mono.ObjectIndex == objectIndex)
                    return mono;
            return null;
        }

    }

    class GardenSprite : HelperSprite
    {
        static Dictionary<GardenSprite, PlantationSlot> targeted = new Dictionary<GardenSprite, PlantationSlot>();
        static Dictionary<int, List<Item_Base>> plantLootCache = new Dictionary<int, List<Item_Base>>();
        public override float MaxDistance => base.MaxDistance * BenevolentSprites.GardenRange;
        public GardenSprite(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0, 0.125f), Random.Range(0.875f, 1), 0), objectIndex)
        {
            targeted.Add(this, null);
        }

        public override void Kill()
        {
            targeted.Remove(this);
            base.Kill();
        }

        internal override bool tryInteract()
        {
            if (targetObject == null)
                return true;
            if (targetObject == box.transform)
                return tryDepositHeld();
            if (box.transform.IsRepelled() || targeted[this].plant == null || targeted[this].plant.transform.IsRepelled() || !targeted[this].plant.FullyGrown())
            {
                targeted[this] = null;
                return true;
            }
            if (SqrDistanceFromTarget > sqrInteractDistance)
                return false;
            holding.AddRange(targeted[this].plant.pickupComponent.GetAllItems());
            var seed = targeted[this].plant.item.UniqueIndex;
            targetObject.GetComponent<Cropplot>().plantManager().Harvest(targeted[this].plant, false);
            new Message_HarvestPlant(Messages.PlantManager_HarvestPlant, targetObject.GetComponent<Cropplot>().plantManager(), targeted[this].plant, false).Broadcast(NetworkChannel.Channel_Game);
            foreach (var item in holding)
                if (item.baseItem.UniqueIndex == seed)
                {
                    PlantSeed(targetObject.GetComponent<Cropplot>(), seed);
                    if (item.Amount == 1)
                        holding.Remove(item);
                    else
                        item.Amount--;
                    break;
                }
            targeted[this] = null;
            return true;
        }
        internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
        {
            float dist = float.MaxValue;
            target = null;
            targetOffset = Vector3.zero;
            if (box.transform.IsRepelled())
                return;
            targeted[this] = null;
            foreach (var cropplot in PlantManager.allCropplots)
            {
                if (cropplot is Cropplot_Grass)
                    continue;
                foreach (var plantation in cropplot.plantationSlots)
                {
                    if (targeted.ContainsValue(plantation) || plantation.transform.IsRepelled())
                        continue;
                    var newDist = (box.transform.position - plantation.transform.position).sqrMagnitude;
                    if (plantation.plant && plantation.plant.FullyGrown() && newDist < dist && ExclusiveCollect(plantation.plant))
                    {
                        target = cropplot;
                        targetOffset = plantation.plant.transform.localPosition + Vector3.up * 0.2f;
                        dist = newDist;
                        targeted[this] = plantation;
                    }
                }
            }
            if (target)
            {
                if (Mathf.Sqrt(dist) > MaxDistance)
                {
                    target = null;
                    targetOffset = Vector3.zero;
                    targeted[this] = null;
                }
                else if (!box.IsOpen && box.GetInventoryReference().GetItemCount(targeted[this].plant.item) > (BenevolentSprites.KeepItem > 0 ? 1 : 0))
                {
                    holding.AddRange(box.GetInventoryReference().TakeItems(targeted[this].plant.item, 1));
                    box.Close();
                }
            }
            else
                targeted[this] = null;
        }

        static void PlantSeed(Cropplot crop, int ItemIndex)
        {
            var msg = new Message_Sprite_PlantSeed(crop, ItemIndex, SaveAndLoad.GetUniqueObjectIndex(), ComponentManager<WeatherManager>.Value.GetCurrentWeatherType() == UniqueWeatherType.Rain);
            msg.Use();
            msg.Message.Broadcast();
        }

        bool ExclusiveCollect(Plant plant)
        {
            if (!BenevolentSprites.EC_Garden)
                return true;
            List<Item_Base> loot;
            if (plantLootCache.ContainsKey(plant.item.UniqueIndex))
                loot = plantLootCache[plant.item.UniqueIndex];
            else
            {
                loot = plant.pickupComponent.GetAllPossible();
                loot.AddUniqueOnly(plant.item);
                plantLootCache.Add(plant.item.UniqueIndex, loot);
            }
            foreach (var slot in box.GetInventoryReference().allSlots)
                if (slot.HasValidItemInstance() && slot.itemInstance.UniqueName != "Plank" && slot.itemInstance.UniqueName != "Thatch")
                    foreach (var item in loot)
                        if (slot.itemInstance.UniqueIndex == item.UniqueIndex)
                            return true;
            return false;
        }

        public override void RestoreData(byte[] data)
        {
            if (targetObject.GetComponent<Cropplot>())
                targeted[this] = targetObject.GetComponent<Cropplot>().plantationSlots[data.Integer(0)];
        }
        public override byte[] GenerateData()
        {
            if (targeted[this] != null && targetObject.GetComponent<Cropplot>())
                return targetObject.GetComponent<Cropplot>().plantationSlots.IndexOf(targeted[this]).Bytes();
            return new byte[0];
        }

        public override MonoBehaviour_ID FindTarget(uint objectIndex)
        {
            foreach (var cropplot in PlantManager.allCropplots)
                if (cropplot.ObjectIndex == objectIndex)
                    return cropplot;
            return base.FindTarget(objectIndex);
        }
    }

    class AnimalSprite : HelperSprite
    {
        static Dictionary<AnimalSprite, MonoBehaviour_ID> targeted = new Dictionary<AnimalSprite, MonoBehaviour_ID>();
        public override float MaxDistance => base.MaxDistance * BenevolentSprites.AnimalRange;
        public AnimalSprite(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0.125f, 0.25f), 0, Random.Range(0.875f, 1)), objectIndex)
        {
            targeted.Add(this, null);
        }
        public override void Kill()
        {
            targeted.Remove(this);
            base.Kill();
        }

        internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
        {
            target = null;
            targetOffset = Vector3.zero;
            if (box.transform.IsRepelled())
                return;
            float dist = float.MaxValue;
            targeted[this] = null;
            Item_Base requiredItem = null;
            var itemCount = new Dictionary<Item_Base, int>();
            foreach (var animal in BenevolentSprites.animals)
            {
                if (animal == null || animal.DomesticState != DomesticStateType.Raft || targeted.ContainsValue(animal) || animal.transform.IsRepelled())
                    continue;
                var newDist = (box.transform.position - animal.transform.position).sqrMagnitude;
                if (!animal.Resource || !animal.Resource.IsReady || newDist >= dist)
                    continue;
                var collectionItem = animal.Resource.resource.collectionItem;
                itemCount.TryAdd(collectionItem, box.GetInventoryReference().GetItemCount(collectionItem));
                if ((collectionItem.MaxUses != 1 || (!box.IsOpen && itemCount[collectionItem] > (BenevolentSprites.KeepItem > 1 ? 1 : 0))) && ExclusiveCollect(animal))
                {
                    if (collectionItem.MaxUses == 1)
                        requiredItem = collectionItem;
                    else
                        requiredItem = null;
                    target = animal;
                    targetOffset = Vector3.up * 0.2f;
                    dist = newDist;
                    targeted[this] = animal;
                }
            }
            foreach (var item in BenevolentSprites.eggs)
            {
                if (item == null || targeted.ContainsValue(item) || item.transform.IsRepelled())
                    continue;
                var newDist = (box.transform.position - item.transform.position).sqrMagnitude;
                if (newDist < dist && ExclusiveCollect(item))
                {
                    requiredItem = null;
                    target = item;
                    targetOffset = Vector3.up * 0.2f;
                    dist = newDist;
                    targeted[this] = item;
                }
            }
            foreach (var hive in BenevolentSprites.beehives)
            {
                if (hive == null || targeted.ContainsValue(hive) || hive.transform.IsRepelled())
                    continue;
                var newDist = (box.transform.position - hive.transform.position).sqrMagnitude;
                if (hive.currentHoneyLevelIndex != -1 && newDist < dist && ExclusiveCollect(hive))
                {
                    requiredItem = null;
                    target = hive;
                    targetOffset = Vector3.up * 0.2f;
                    dist = newDist;
                    targeted[this] = hive;
                }
            }
            if (BirdsNest.AllNests != null)
                foreach (var nest in BirdsNest.AllNests)
                {
                    if (targeted.ContainsValue(nest) || nest.transform.IsRepelled())
                        continue;
                    var newDist = (box.transform.position - nest.transform.position).sqrMagnitude;
                    if ((nest.HasFeather || nest.HasEgg) && newDist < dist)
                    {
                        var v = ExclusiveCollect(nest);
                        if (!v.Item1 && !v.Item2)
                            continue;
                        requiredItem = null;
                        target = nest;
                        targetOffset = Vector3.up * 0.2f;
                        dist = newDist;
                        targeted[this] = nest;
                    }
                }
            if (target)
            {
                if (Mathf.Sqrt(dist) > MaxDistance)
                {
                    target = null;
                    targetOffset = Vector3.zero;
                    targeted[this] = null;
                }
                else if (requiredItem)
                {
                    holding.AddRange(box.GetInventoryReference().TakeItemUses(requiredItem, 1));
                    box.Close();
                }
            }
        }
        internal override bool tryInteract()
        {
            if (targetObject == null)
                return true;
            if (targetObject == box.transform)
                return tryDepositHeld();
            if (targetObject.IsRepelled() || box.transform.IsRepelled())
                return true;
            ResourceRegenerative resource = null;
            var animal = targetObject.GetComponent<AI_NetworkBehaviour_Domestic_Resource>();
            var pickup = targetObject.GetComponent<PickupItem_Networked>();
            var beehive = targetObject.GetComponent<BeeHive>();
            var nest = targetObject.GetComponent<BirdsNest>();
            if (animal)
            {
                resource = animal.Resource;
                if (!resource.IsReady || animal.DomesticState != DomesticStateType.Raft)
                {
                    targeted[this] = null;
                    return true;
                }
            }
            if ((beehive && beehive.currentHoneyLevelIndex == -1) || (nest && !nest.HasEgg && !nest.HasFeather))
            {
                targeted[this] = null;
                return true;
            }
            if (SqrDistanceFromTarget > sqrInteractDistance)
                return false;
            if (animal)
            {
                Item_Base RequiredItem = resource.resource.collectionItem;
                Item_Base _pickup = resource.HarvestResource();
                holding.Add(new ItemInstance(_pickup, 1, _pickup.MaxUses));
                if (RequiredItem.MaxUses == 1)
                    holding.Remove(RequiredItem, 1);
            }
            else if (beehive)
            {
                holding.AddAll(beehive.CurrentHoneyLevel.yield.yieldAssets);
                new Message_NetworkBehaviour_ID_SteamID(Messages.BeeHiveHarvestOutput, ComponentManager<Raft_Network>.Value.NetworkIDManager, beehive.ObjectIndex, new CSteamID(0)).Broadcast();
                Traverse.Create(beehive).Method("HarvestYield", new Type[] { typeof(Network_Player) }, new object[] { null }).GetValue();
            }
            else if (nest)
            {
                var b = ExclusiveCollect(nest);
                if (b.Item1)
                {
                    var item = Traverse.Create(nest).Field("eggItem").GetValue<Item_Base>();
                    holding.Add(new ItemInstance(item, nest.EggCount, item.MaxUses));
                    while (nest.PickupEgg(null))
                        new Message_NetworkBehaviour_SteamID(Messages.BirdsNest_PickupEgg, nest, 0).Broadcast();
                }
                if (b.Item2)
                {
                    var item = Traverse.Create(nest).Field("featherItem").GetValue<Item_Base>();
                    holding.Add(new ItemInstance(item, nest.FeatherCount, item.MaxUses));
                    while (nest.PickupFeather(null))
                        new Message_NetworkBehaviour_SteamID(Messages.BirdsNest_PickupFeather, nest, 0).Broadcast();
                }
            }
            else
            {
                holding.AddRange(pickup.PickupItem.GetAllItems());
                pickup.Remove();
            }
            targeted[this] = null;
            return true;
        }

        bool ExclusiveCollect(AI_NetworkBehaviour_Domestic_Resource animal)
        {
            if (!BenevolentSprites.EC_Animal)
                return true;
            var item = animal.Resource.resource.resource.UniqueIndex;
            foreach (var slot in box.GetInventoryReference().allSlots)
                if (slot.HasValidItemInstance() && slot.itemInstance.UniqueIndex == item)
                    return true;
            return false;
        }

        bool ExclusiveCollect(PickupItem_Networked pickup)
        {
            if (!BenevolentSprites.EC_Animal)
                return true;
            List<Item_Base> loot = pickup.PickupItem.GetAllPossible();
            foreach (var slot in box.GetInventoryReference().allSlots)
                if (slot.HasValidItemInstance())
                    foreach (var item in loot)
                        if (slot.itemInstance.UniqueIndex == item.UniqueIndex)
                            return true;
            return false;
        }

        bool ExclusiveCollect(BeeHive hive)
        {
            if (!BenevolentSprites.EC_Animal2)
                return true;
            List<Item_Base> loot = hive.CurrentHoneyLevel.yield.GetAllPossible();
            foreach (var slot in box.GetInventoryReference().allSlots)
                if (slot.HasValidItemInstance())
                    foreach (var item in loot)
                        if (slot.itemInstance.UniqueIndex == item.UniqueIndex)
                            return true;
            return false;
        }

        (bool,bool) ExclusiveCollect(BirdsNest nest)
        {
            if (!BenevolentSprites.EC_Animal3)
                return (true,true);
            return (
                nest.HasEgg && box.GetInventoryReference().GetItemCount(Traverse.Create(nest).Field("eggItem").GetValue<Item_Base>()) > 0,
                nest.HasFeather && box.GetInventoryReference().GetItemCount(Traverse.Create(nest).Field("featherItem").GetValue<Item_Base>()) > 0
                );
        }

        public override void RestoreData(byte[] data)
        {
            targeted[this] = targetObject.GetComponent<MonoBehaviour_ID>();
        }

        public override MonoBehaviour_ID FindTarget(uint objectIndex)
        {
            foreach (var animal in BenevolentSprites.animals)
                if (animal.ObjectIndex == objectIndex)
                    return animal;
            foreach (var item in BenevolentSprites.eggs)
                if (item.ObjectIndex == objectIndex)
                    return item;
            foreach (var hive in BenevolentSprites.beehives)
                if (hive.ObjectIndex == objectIndex)
                    return hive;
            foreach (var nest in BirdsNest.AllNests)
                if (nest.ObjectIndex == objectIndex)
                    return nest;
            return base.FindTarget(objectIndex);
        }
    }

    class FireSprite : HelperSprite
    {
        static Dictionary<FireSprite, CookingSlotTargets> targeted = new Dictionary<FireSprite, CookingSlotTargets>();
        public override float MaxDistance => base.MaxDistance * BenevolentSprites.FireRange;
        public FireSprite(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0.875f, 1), Random.Range(0, 0.125f), 0), objectIndex)
        {
            targeted.Add(this, CookingSlotTargets.Null);
        }
        public override void Kill()
        {
            targeted.Remove(this);
            base.Kill();
        }

        public static bool IsTargeted(CookingSlot slot) => targeted.ContainsValue(slot);

        internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
        {
            target = null;
            targetOffset = Vector3.zero;
            if (box.transform.IsRepelled())
                return;
            float dist = float.MaxValue;
            targeted[this] = CookingSlotTargets.Null;
            Item_Base cookItem = null;
            Cost fuel = null;
            var fueling = true;
            var maxDist = MaxDistance;
            var newTarget = CookingSlotTargets.Null;
            foreach (var stand in BenevolentSprites.stands)
            {
                if (stand == null || stand is Block_CookingStand_Purifier)
                    continue;
                var f = 0;
                if (!box.IsOpen && stand.fuel != null)
                    f = Mathf.Max(Mathf.Min(stand.fuel.Missing() - InboundFuel(stand), box.GetInventoryReference().GetItemCount(stand.fuel.fuelItem) - (BenevolentSprites.KeepItem > 1 ? 1 : 0)), 0);
                foreach (var slot in stand.cookingSlots)
                {
                    var flagEmpty = !slot.IsBusy && !box.IsOpen;
                    var flagComplete = slot.IsComplete;
                    if ((!flagComplete && !flagEmpty && f == 0) || slot.transform.IsRepelled())
                        continue;
                    var newDist = Vector3.Distance(box.transform.position, slot.transform.position);
                    if ((newDist >= dist && !fueling) || newDist > maxDist)
                        continue;
                    Item_Base item = null;
                    List<CookingSlot> fetched = null;
                    if (f != 0 && (targeted.ContainsValue(slot) || (slot.connectedSlot && targeted.ContainsValue(slot.connectedSlot))))
                        continue;
                    else if (flagEmpty)
                    {
                        Patch_GetCookingSlots.spriteCall = true;
                        try
                        {
                            item = box.GetInventoryReference().FindItem(stand, out fetched, BenevolentSprites.KeepItem > 0);
                        }
                        catch (Exception e)
                        {
                            Debug.LogError(e);
                        }
                        Patch_GetCookingSlots.spriteCall = false;
                        if (!item || fetched == null || targeted.ContainsValue(fetched))
                        {
                            if (f == 0)
                                continue;
                            item = null;
                        }
                    }
                    else if (flagComplete)
                        flagComplete = ExclusiveCollect(slot);
                    if (flagComplete || item || (f != 0 && fueling))
                    {
                        if (stand.fuel != null)
                            fuel = new Cost(stand.fuel.fuelItem, f);
                        cookItem = item;
                        target = stand;
                        if (!flagComplete && !item && !box.IsOpen)
                        {
                            fueling = true;
                            targetOffset = Vector3.up * 0.2f;
                        }
                        else
                        {
                            fueling = false;
                            if (flagComplete)
                                targetOffset = slot.transform.localPosition + Vector3.up * 0.2f;
                            else if (item)
                                targetOffset = fetched[0].transform.localPosition + Vector3.up * 0.2f;
                        }
                        dist = newDist;
                        if (item)
                            newTarget = fetched;
                        else
                        {
                            var l = new List<CookingSlot>();
                            var s = slot;
                            if (slot.connectedSlot)
                                s = slot.connectedSlot;
                            l.Add(s);
                            if (flagComplete)
                                foreach (var i in slot.GetComponentInParent<Block_CookingStand>().cookingSlots)
                                    if (i.connectedSlot == s)
                                        l.Add(i);
                            newTarget = l;
                        }
                    }
                }
            }
            if (target)
            {
                if (dist > maxDist)
                {
                    target = null;
                    targetOffset = Vector3.zero;
                    return;
                }
                targeted[this] = newTarget;
                if (cookItem)
                {
                    holding.AddRange(box.GetInventoryReference().TakeItemUses(cookItem, 1));
                    box.Close();
                }
                if (fuel != null && fuel.amount != 0)
                {
                    holding.AddRange(box.GetInventoryReference().TakeItems(fuel.item, fuel.amount));
                    box.Close();
                }

            }
        }
        internal override bool tryInteract()
        {
            if (targetObject == null)
                return true;
            if (targetObject == box.transform)
                return tryDepositHeld();
            if (targetObject.IsRepelled() || box.transform.IsRepelled())
                return true;
            var target = targeted[this];
            foreach (var slot in target.Slots)
                if (!slot.IsComplete && slot.IsBusy && !(target.stand.fuel != null && holding.Contains(target.stand.fuel.fuelItem) && !target.stand.fuel.HasMaxFuel()))
                {
                    targeted[this] = CookingSlotTargets.Null;
                    return true;
                }
            if (SqrDistanceFromTarget > sqrInteractDistance)
                return false;
            if (target.stand.fuel != null && holding.Contains(target.stand.fuel.fuelItem) && !target.stand.fuel.HasMaxFuel())
            {
                var m = Mathf.Min(target.stand.fuel.Missing(), holding.GetCount(target.stand.fuel.fuelItem));
                AddFuel(target.stand, m);
                holding.Remove(target.stand.fuel.fuelItem, m);
            }
            if (target.Slot.IsComplete && ExclusiveCollect(target.Slot))
            {
                holding.Add(target.Slot.CurrentItem.settings_cookable.CookingResult);
                ClearItem(target.stand, target.Slot);
            }
            else if (!target.Slot.IsBusy)
            {
                Item_Base item = null;
                foreach (var i in holding)
                {
                    bool all = true;
                    foreach (var s in target.Slots)
                        if (!s.CanCookItem(i.baseItem))
                        {
                            all = false;
                            break;
                        }
                    if (all)
                    {
                        item = i.baseItem;
                        break;
                    }
                }
                if (item != null)
                {
                    InsertItem(target, item);
                    holding.Remove(item, 1);
                }
            }
            targeted[this] = CookingSlotTargets.Null;
            return true;
        }

        bool ExclusiveCollect(CookingSlot slot) => !BenevolentSprites.EC_Fire || box.GetInventoryReference().GetItemCount(slot.CurrentItem) != 0 || box.GetInventoryReference().GetItemCount(slot.CurrentItem.settings_cookable.CookingResult.item) != 0;

        static void ClearItem(Block_CookingStand stand, CookingSlot slot)
        {
            var msg = new Message_Sprite_ClearCooker(stand, slot);
            msg.Use();
            msg.Message.Broadcast();
        }

        static void InsertItem(CookingSlotTargets slots, Item_Base item)
        {
            var msg = new Message_Sprite_InsertCooker(slots, item);
            msg.Use();
            msg.Message.Broadcast();
        }

        static void AddFuel(Block_CookingStand stand, int amount)
        {
            var msg = new Message_Sprite_AddFuel(stand, amount);
            msg.Use();
            msg.Message.Broadcast();
        }

        static int InboundFuel(Block_CookingStand stand)
        {
            var i = 0;
            foreach (var p in targeted)
                if (p.Value.stand == stand)
                    i += p.Key.holding.GetCount(stand.fuel.fuelItem);
            return i;
        }

        public override void RestoreData(byte[] data) => targeted[this] = data.CookingSlotTargets(0);
        public override byte[] GenerateData() => targeted[this].Bytes();

        public override MonoBehaviour_ID FindTarget(uint objectIndex)
        {
            foreach (var stand in BenevolentSprites.stands)
                if (stand.ObjectIndex == objectIndex)
                    return stand;
            return base.FindTarget(objectIndex);
        }
    }

    class FireSprite2 : HelperSprite
    {
        static Dictionary<FireSprite2, CookingTable> targeted = new Dictionary<FireSprite2, CookingTable>();
        SO_CookingTable_Recipe Recipe = null;
        public override float MaxDistance => base.MaxDistance * BenevolentSprites.Fire2Range;
        public FireSprite2(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0.5f, 0.625f), Random.Range(0, 0.125f), 0), objectIndex)
        {
            targeted.Add(this, null);
        }
        public override void Kill()
        {
            targeted.Remove(this);
            base.Kill();
        }

        internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
        {
            target = null;
            targetOffset = Vector3.zero;
            if (box.transform.IsRepelled())
                return;
            float dist = float.MaxValue;
            targeted[this] = null;
            Cost requiredItem = null;
            CookingTable_Recipe_UI recipe = null;
            Cost fuel = null;
            var fueling = true;
            var itemCount = new Dictionary<Item_Base, int>();
            var maxDist = MaxDistance;
            var recipeCache = new Dictionary<SO_CookingTable_Recipe, bool>();
            if (!box.IsOpen)
                foreach (var table in BenevolentSprites.tables)
                {
                    if (table == null || targeted.ContainsValue(table) || table.transform.IsRepelled())
                        continue;
                    var newDist = Vector3.Distance(box.transform.position, table.transform.position);
                    if ((newDist >= dist && !fueling) || newDist > maxDist)
                        continue;
                    var collectionItem = Traverse.Create(table).Field("pickupFoodItem").GetValue<Item_Base>();
                    CookingTable_Recipe_UI cooked = null;
                    if (table.CurrentRecipe == null)
                        cooked = table.FindRecipe(box.GetInventoryReference().GetAllItems(),true);
                    itemCount.TryAdd(collectionItem, box.GetInventoryReference().GetItemCount(collectionItem));
                    var collecting = table.Portions != 0 && itemCount[collectionItem] > (BenevolentSprites.KeepItem > 1 ? 1 : 0);
                    if (collecting && BenevolentSprites.EC_Fire2)
                    {
                        if (recipeCache.ContainsKey(table.CurrentRecipe))
                            collecting = recipeCache[table.CurrentRecipe];
                        else
                        {
                            var result = table.CurrentRecipe.Result.UniqueIndex;
                            foreach (var slot in box.GetInventoryReference().allSlots)
                                if (slot.HasValidItemInstance())
                                {
                                    if (result == slot.itemInstance.UniqueIndex)
                                        goto leaveCollectionCheck;
                                    foreach (var cost in table.CurrentRecipe.RecipeCost)
                                        if (cost.ContainsItem(slot.itemInstance.baseItem))
                                            goto leaveCollectionCheck;
                                }
                            collecting = false;
                        leaveCollectionCheck:
                            recipeCache.Add(table.CurrentRecipe, collecting);
                        }
                    }
                    var f = 0;
                    var fC = table.GetComponentInChildren<FuelNetwork>();
                    if (fC)
                        f = Mathf.Max(Mathf.Min(fC.Fuel.Missing(), box.GetInventoryReference().GetItemCount(fC.Fuel.fuelItem) - (BenevolentSprites.KeepItem > 1 ? 1 : 0)), 0);
                    if (cooked || collecting || (f != 0 && fueling))
                    {
                        fueling = f != 0;
                        if (fueling)
                            fuel = new Cost(fC.Fuel.fuelItem, f);
                        else
                            fuel = null;
                        recipe = null;
                        requiredItem = null;
                        if (table.CurrentRecipe == null)
                        {
                            recipe = cooked;
                            fueling = false;
                        }
                        else if (collecting)
                        {
                            requiredItem = new Cost(collectionItem, Mathf.Min((int)table.Portions, itemCount[collectionItem] - (BenevolentSprites.KeepItem > 1 ? 1 : 0)));
                            fueling = false;
                        }
                        target = table;
                        targetOffset = Vector3.up * 0.4f;
                        dist = newDist;
                        targeted[this] = table;
                    }
                }
            Recipe = null;
            if (target)
            {
                if (dist > maxDist)
                {
                    target = null;
                    targetOffset = Vector3.zero;
                    targeted[this] = null;
                }
                else
                {
                    if (requiredItem != null && requiredItem.amount > 0)
                    {
                        holding.AddRange(box.GetInventoryReference().TakeItems(requiredItem.item, requiredItem.amount));
                        box.Close();
                    }
                    else if (recipe)
                    {
                        Recipe = recipe.Recipe;
                        holding.AddRange(box.GetInventoryReference().TakeItems(recipe.Recipe.RecipeCost));
                        box.Close();
                    }
                    if (fuel != null && fuel.amount != 0)
                    {
                        holding.AddRange(box.GetInventoryReference().TakeItems(fuel.item, fuel.amount));
                        box.Close();
                    }
                }
            }
        }
        internal override bool tryInteract()
        {
            if (targetObject == null)
                return true;
            if (targetObject == box.transform)
                return tryDepositHeld();
            if (targetObject.IsRepelled() || box.transform.IsRepelled())
                return true;
            var target = targeted[this];
            var f = targetObject.GetComponentInChildren<FuelNetwork>();
            if (!(f && holding.Contains(f.Fuel.fuelItem) && !f.Fuel.HasMaxFuel()) && (Recipe == null ? target.Portions == 0 : target.CurrentRecipe))
            {
                targeted[this] = null;
                return true;
            }
            if (SqrDistanceFromTarget > sqrInteractDistance)
                return false;
            if (f && holding.Contains(f.Fuel.fuelItem) && !f.Fuel.HasMaxFuel())
            {
                var m = Mathf.Min(f.Fuel.Missing(), holding.GetCount(f.Fuel.fuelItem));
                AddFuel(target, m);
                holding.Remove(f.Fuel.fuelItem, m);
            }
            if (Recipe)
            {
                ForceStart(target, Recipe);
                holding.Remove(Recipe.RecipeCost);
            }
            else if (target.Portions != 0)
            {
                var item = Traverse.Create(target).Field("pickupFoodItem").GetValue<Item_Base>();
                var amount = (int)target.Portions;
                if (item)
                {
                    amount = Mathf.Min(holding.GetCount(item), amount);
                    holding.Remove(item, amount);
                }
                holding.Add(new Cost(target.CurrentRecipe.Result, amount));
                RemoveTablePortions(target,amount);
            }
            targeted[this] = null;
            return true;
        }

        static void AddFuel(CookingTable table, int amount)
        {
            var msg = new Message_Sprite_AddFuel(table, amount);
            msg.Use();
            msg.Message.Broadcast();
        }

        static void ForceStart(CookingTable table, SO_CookingTable_Recipe recipe)
        {
            var msg = new Message_Sprite_InsertTable(table, recipe);
            msg.Use();
            msg.Message.Broadcast();
        }

        static void RemoveTablePortions(CookingTable table, int amount)
        {
            var msg = new Message_Sprite_ClearTable(table,amount);
            msg.Use();
            msg.Message.Broadcast();
        }

        public override void RestoreData(byte[] data)
        {
            targeted[this] = targetObject.GetComponent<CookingTable>();
            var ind = data.Integer(0);
            if (ind == -1)
                Recipe = null;
            else
                foreach (var r in Traverse.Create<CookingTable>().Field("allRecipes").GetValue<SO_CookingTable_Recipe[]>())
                    if (r.RecipeIndex == ind)
                        Recipe = r;
        }

        public override byte[] GenerateData() => Recipe ? Recipe.RecipeIndex.Bytes() : (-1).Bytes();

        public override MonoBehaviour_ID FindTarget(uint objectIndex)
        {
            foreach (var table in BenevolentSprites.tables)
                if (table.ObjectIndex == objectIndex)
                    return table;
            return base.FindTarget(objectIndex);
        }
    }

    class CleanerSprite : HelperSprite
    {
        static Dictionary<CleanerSprite, MonoBehaviour_ID> targeted = new Dictionary<CleanerSprite, MonoBehaviour_ID>();
        public static Dictionary<Transform, MonoBehaviour> fishNetCache = new Dictionary<Transform, MonoBehaviour>();
        public override float MaxDistance => base.MaxDistance * BenevolentSprites.CleanerRange;
        public CleanerSprite(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(Random.Range(0.875f, 1), Random.Range(0.875f, 1), 0), objectIndex)
        {
            targeted.Add(this, null);
        }
        public override void Kill()
        {
            targeted.Remove(this);
            base.Kill();
        }

        internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
        {
            target = null;
            targetOffset = Vector3.zero;
            if (box.transform.IsRepelled())
                return;
            float dist = float.MaxValue;
            targeted[this] = null;
            var maxDist = MaxDistance;
            if (BenevolentSprites.seagulls != null && (!BenevolentSprites.EC_Clean || box.GetInventoryReference().GetItemCount(ItemManager.GetItemByName("Feather")) > 0))
                foreach (var seagull in BenevolentSprites.seagulls)
                {
                    if (seagull == null || targeted.ContainsValue(seagull))
                        continue;
                    var newDist = (box.transform.position - seagull.transform.position).sqrMagnitude;
                    if (newDist < dist && seagull.currentState == SeagullState.Peck)
                    {
                        target = seagull;
                        targetOffset = Vector3.up * 0.2f;
                        dist = newDist;
                        targeted[this] = seagull;
                    }
                }
            if (target == null || Mathf.Sqrt(dist) > maxDist)
            {
                if (!BenevolentSprites.EC_Clean || box.GetInventoryReference().allSlots.Any(x => x.HasValidItemInstance() && x.itemInstance.UniqueName.StartsWith("Placeable_CollectionNet")))
                    foreach (var net in BenevolentSprites.itemnets)
                    {
                        if (net == null || targeted.ContainsValue(net) || net.transform.IsRepelled())
                            continue;
                        var newDist = (box.transform.position - net.transform.position).sqrMagnitude;
                        if (newDist < dist && net.GetComponentInChildren<ItemCollector>(true).collectedItems.Count != 0)
                        {
                            target = net;
                            targetOffset = Vector3.up * 0.2f;
                            dist = newDist;
                            targeted[this] = net;
                        }
                    }
                if (BenevolentSprites.fishnets != null && (!BenevolentSprites.EC_Clean || box.GetInventoryReference().GetItemCount(ItemManager.GetItemByName("Placeable_FishingNet")) > 0))
                    foreach (var net in BenevolentSprites.fishnets.Value)
                    {
                        if (net == null)
                            continue;
                        var block = Traverse.Create(net).Field("fishingNet").GetValue<Block>();
                        if (block == null || targeted.ContainsValue(block) || block.transform.IsRepelled())
                            continue;
                        var newDist = (box.transform.position - block.transform.position).sqrMagnitude;
                        if (newDist < dist && Traverse.Create(net).Field("fishCount").GetValue<int>() != 0)
                        {
                            fishNetCache.TryAdd(block.transform, net);
                            target = block;
                            targetOffset = Vector3.zero;
                            dist = newDist;
                            targeted[this] = block;
                        }
                    }
            }
            if (target)
            {
                if (Mathf.Sqrt(dist) > maxDist)
                {
                    target = null;
                    targetOffset = Vector3.zero;
                    targeted[this] = null;
                }
            }
        }
        internal override bool tryInteract()
        {
            if (targetObject == null)
                return true;
            if (targetObject == box.transform)
                return tryDepositHeld();
            if (targetObject.IsRepelled() || box.transform.IsRepelled())
                return true;
            var seagull = targetObject.GetComponent<Seagull>();
            var net = targetObject.GetComponentInChildren<ItemCollector>(true);
            var fisher = GetFishNetFromBlock(targetObject);
            if ((net && net.collectedItems.Count == 0) || (seagull && seagull.currentState != SeagullState.Peck))
            {
                targeted[this] = null;
                return true;
            }
            if (SqrDistanceFromTarget > sqrInteractDistance * 2)
                return false;
            if (seagull)
            {
                seagull.entityComponent.Damage(5f, seagull.transform.position, Vector3.down, EntityType.Enemy);
                if (seagull.entityComponent.IsDead)
                {
                    holding.AddRange(seagull.pickupItemChanneling.pickupItem.GetAllItems());
                    seagull.pickupItem.networkID.Remove();
                }
            }
            else if (net)
            {
                foreach (var pickup in net.collectedItems)
                {
                    var newItems = pickup.PickupItem.GetAllItems();
                    foreach (var item in newItems)
                        if (item.settings_recipe.IsBlueprint)
                            ComponentManager<Inventory_ResearchTable>.Value.ResearchBlueprint(item.baseItem);
                    holding.AddRange(newItems);
                }

                ClearAll(net);
            }
            else if (fisher)
            {
                foreach (var item in Traverse.Create(fisher).Field("caughtFishItem").GetValue<Item_Base[]>())
                    if (item)
                        holding.Add(item);
                    else
                        break;
                ClearFish(targetObject.GetComponent<Block>());

            }
            targeted[this] = null;
            return true;
        }

        static void ClearAll(ItemCollector collector)
        {
            var msg = new Message_Sprite_ClearAll(collector);
            msg.Use();
            msg.Message.Broadcast();
        }

        static void ClearFish(Block net)
        {
            var msg = new Message_Sprite_ClearFish(net);
            msg.Use();
            msg.Message.Broadcast();
        }

        public override void RestoreData(byte[] data)
        {
            targeted[this] = targetObject.GetComponent<MonoBehaviour_ID>();
        }

        public override MonoBehaviour_ID FindTarget(uint objectIndex)
        {
            if (BenevolentSprites.seagulls != null)
                foreach (var seagull in BenevolentSprites.seagulls)
                    if (seagull.ObjectIndex == objectIndex)
                        return seagull;
            foreach (var net in BenevolentSprites.itemnets)
                if (net.ObjectIndex == objectIndex)
                    return net;
            foreach (var block in BlockCreator.GetPlacedBlocks())
                if (block.ObjectIndex == objectIndex)
                    return block;
            return base.FindTarget(objectIndex);
        }

        public static MonoBehaviour GetFishNetFromBlock(Transform block)
        {
            if (BenevolentSprites.fishnets != null && block.GetComponent<Block>())
            {
                if (fishNetCache.ContainsKey(block))
                    return fishNetCache[block];
                foreach (var net in BenevolentSprites.fishnets.Value)
                {
                    if (net == null)
                        continue;
                    var b = Traverse.Create(net).Field("fishingNet").GetValue<Block>();
                    if (b && b.transform == block)
                    {
                        fishNetCache.Add(block, net);
                        return net;
                    }
                }
            }
            return null;
        }
    }

    class MechanicSprite : HelperSprite
    {
        static Dictionary<MechanicSprite, TankAccess> targeted = new Dictionary<MechanicSprite, TankAccess>();
        public override float MaxDistance => base.MaxDistance * BenevolentSprites.MechanicRange;
        public MechanicSprite(Storage_Small container, Slot slot, uint objectIndex = 0) : base(container, slot, new Color(0, Random.Range(0.125f, 0.250f), Random.Range(0.875f, 1)), objectIndex)
        {
            targeted.Add(this, null);
        }
        public override void Kill()
        {
            targeted.Remove(this);
            base.Kill();
        }

        internal override void pickTarget(out MonoBehaviour_ID target, out Vector3 targetOffset)
        {
            target = null;
            targetOffset = Vector3.zero;
            if (box.transform.IsRepelled())
                return;
            float dist = float.MaxValue;
            targeted[this] = null;
            Item_Base collectionItem = null;
            if (BenevolentSprites.tanks != null)
                foreach (var tank in BenevolentSprites.tanks)
                {
                    if (tank.Tank == null || targeted.ContainsValue(tank) || tank.Tank.transform.IsRepelled())
                        continue;
                    var newDist = (box.transform.position - tank.Receiver.transform.position).sqrMagnitude;
                    if (newDist >= dist)
                        continue;
                    var collect = tank.HasOutput;
                    var put = tank.HasInput;
                    if (collect == put)
                        continue;
                    Item_Base newCollectionItem = null;
                    collect = collect && !tank.IsConnectedToPipe && tank.Tank.IsConsideredHarvestable() && tank.HarvestAmount > 0;
                    put = put && !tank.Tank.IsFull;
                    if (put && !box.IsOpen)
                        newCollectionItem = tank.acceptableTypes.Find((x) => box.GetInventoryReference().GetItemCount(x) > (BenevolentSprites.KeepItem > 1 ? 1 : 0) && tank.Tank.FuelValue(x) + tank.Tank.CurrentTankAmount <= tank.Tank.maxCapacity);
                    if (collect || (put && newCollectionItem))
                    {
                        collectionItem = newCollectionItem;
                        target = tank.Receiver;
                        targetOffset = Vector3.up * 0.2f + tank.Receiver.transform.InverseTransformPoint(tank.Tank.transform.position);
                        dist = newDist;
                        targeted[this] = tank;
                    }
                }
            if (target)
            {
                if (Mathf.Sqrt(dist) > MaxDistance)
                {
                    target = null;
                    targetOffset = Vector3.zero;
                    targeted[this] = null;
                }
                else if (collectionItem)
                {
                    var tank = targeted[this].Tank;
                    int c = 0;
                    var p = new List<ItemInstance>();
                    foreach (var s in box.GetInventoryReference().allSlots)
                        if (s.HasValidItemInstance() && s.itemInstance.UniqueIndex == collectionItem.UniqueIndex && !p.Contains(s.itemInstance))
                        {
                            p.Add(s.itemInstance);
                            c += s.itemInstance.UsesInStack;
                        }
                    c = Mathf.Min((int)((tank.maxCapacity - tank.CurrentTankAmount) / tank.FuelValue(collectionItem)), c);
                    holding.AddRange(box.GetInventoryReference().TakeItemUses(collectionItem, c, BenevolentSprites.KeepItem > 1));
                    box.Close();
                }
            }
        }
        internal override bool tryInteract()
        {
            if (targetObject == null)
                return true;
            if (targetObject == box.transform)
                return tryDepositHeld();
            if (targetObject.IsRepelled() || box.transform.IsRepelled())
                return true;
            var tank = targeted[this];
            if (tank == null)
                return true;
            int c = 0;
            Item_Base item = null;
            if (tank.HasInput)
            {
                foreach (var hold in holding)
                {
                    if (!tank.acceptableTypes.Contains(hold.baseItem))
                        continue;
                    var t = (int)((tank.Tank.maxCapacity - tank.Tank.CurrentTankAmount) / tank.Tank.FuelValue(hold.baseItem));
                    if (t > 0)
                    {
                        c = t;
                        item = hold.baseItem;
                        break;
                    }
                }
                if (item != null)
                    c = Mathf.Min(c, holding.Join((x) => (x.UniqueName == item.UniqueName) ? (item.MaxUses > 1 ? x.UsesInStack : x.Amount) : 0, (x, y) => x + y));
            }
            else if (tank.Tank.IsConsideredHarvestable())
            {
                item = tank.OutputItem;
                c = tank.HarvestAmount;
            }
            if (c == 0)
            {
                targeted[this] = null;
                return true;
            }
            if (SqrDistanceFromTarget > sqrInteractDistance)
                return false;
            if (tank.HasInput)
            {
                tank.Tank.ModifyTankRPC(c * tank.Tank.FuelValue(item), null);
                holding.RemoveUses(item, c);
            }
            else
            {
                tank.Tank.ModifyTankRPC(-tank.Tank.CurrentTankAmount, null);
                holding.Add(new ItemInstance(item, c, item.MaxUses));
            }
            targeted[this] = null;
            return true;
        }

        public override void RestoreData(byte[] data)
        {
            foreach (var tank in BenevolentSprites.tanks)
                if (tank.Receiver.transform == targetObject && tank.Tank.tankID == data.Integer())
                    targeted[this] = tank;
        }
        public override byte[] GenerateData()
        {
            return targeted[this] == null ? 0.Bytes() : targeted[this].Tank.tankID.Bytes();
        }

        public override MonoBehaviour_ID FindTarget(uint objectIndex)
        {
            if (BenevolentSprites.tanks != null)
                foreach (var tank in BenevolentSprites.tanks)
                    if (tank.Receiver.ObjectIndex == objectIndex)
                        return tank.Receiver;
            return base.FindTarget(objectIndex);
        }
    }

    class ModLoadException : Exception
    {
        public ModLoadException(string message) : base(message) { }
    }

    [HarmonyPatch(typeof(ModManagerPage), "ShowModInfo")]
    class Patch_ShowModInfo
    {
        static void Postfix(ModData md)
        {
            if (md.modinfo.mainClass && md.modinfo.mainClass.GetType() == typeof(BenevolentSprites))
                ModManagerPage.modInfoObj.transform.Find("MakePermanent").gameObject.SetActive(true);
        }
    }

    [HarmonyPatch(typeof(Storage_Small), "Close")]
    class Patch_CloseStorage
    {
        static void Postfix(Storage_Small __instance)
        {
            if (BenevolentSprites.gameLoaded && Raft_Network.IsHost)
            {
                foreach (var slot in __instance.GetInventoryReference().allSlots)
                    if (slot.HasSprite())
                    {
                        var s = slot.GetSprite();
                        if (s == null || s.dying)
                        {
                            if (slot.itemInstance.TryGetData(out var data) && data.ContainsKey(BenevolentSprites.dataKey))
                                BenevolentSprites.CreateSprite(data[BenevolentSprites.dataKey]);
                            else
                                BenevolentSprites.CreateSprite(__instance, slot);
                        }
                    }
            }
        }
    }

    [HarmonyPatch(typeof(GameManager), "OnWorldRecievedLate")]
    class Patch_RemoteWorldLoaded
    {
        static void Postfix(Storage_Small __instance)
        {
            BenevolentSprites.gameLoaded = true;
            int i = -1;
            string str = "";
            foreach (var message in BenevolentSprites.waiting)
                try
                {
                    i++;
                    BenevolentSprites.ProcessMessage(message);
                }
                catch (Exception e)
                {
                    str += "\n" + i + "/" + BenevolentSprites.waiting.Count + " | Message type: " + MessageType.getName(message.appBuildID) + " | Top Stacktrace : " + e.StackTrace.Split('\n')[0];
                }
            if (str.Length != 0)
                Debug.LogWarning("Some qued messages failed:" + str);
            BenevolentSprites.waiting.Clear();
        }
    }

    [HarmonyPatch(typeof(RGD_Slot), MethodType.Constructor, typeof(Slot), typeof(int))]
    class Patch_SaveSlot
    {
        static void Prefix(ref bool __state, Slot slot)
        {
            if (slot == null || !slot.HasValidItemInstance() || !Environment.StackTrace.Contains("SaveWorld"))
                return;
            var sprite = slot.GetSprite();
            __state = sprite != null && !sprite.dying;
            if (__state)
                slot.itemInstance.SetValue(BenevolentSprites.dataKey, new Message_Sprite_Recreate(sprite).Message.password + sprite.holding.Bytes().String() + sprite.GenerateData().String());
            //Debug.Log("Sprite data: " + slot.itemInstance.exclusiveString.Length);
        }
        static void Postfix(bool __state, Slot slot)
        {
            if (__state)
                slot.itemInstance.RemoveValue(BenevolentSprites.dataKey);
        }
    }

    [HarmonyPatch(typeof(Slot), "RefreshComponents")]
    class Patch_ChangeSlot
    {
        public class store<T> { public T value; public static implicit operator T(store<T> v) => v.value; public static implicit operator store<T>(T v) => new store<T>() { value = v }; }
        public static Dictionary<Slot, store<ItemInstance>> prevs = new Dictionary<Slot, store<ItemInstance>>();
        static void Prefix(Slot __instance)
        {
            if (prevs.TryGetValue(__instance, out var v))
            {
                if (v.value != __instance.itemInstance)
                {
                    if (v.value?.baseItem?.UniqueName != null)
                        Clear(v.value);
                    if (__instance.itemInstance?.baseItem?.UniqueName != null)
                        Clear(__instance.itemInstance);
                    v.value = __instance.itemInstance;
                }
            }
            else
            {
                if (__instance.itemInstance?.baseItem?.UniqueName != null)
                    Clear(__instance.itemInstance);
                prevs[__instance] = __instance.itemInstance;
            }
        }
        static void Clear(ItemInstance item)
        {
            if (item.UniqueName.IsSprite() && BenevolentSprites.gameLoaded)
            {
                if (item.TryGetData(out _))
                    item.RemoveValue(BenevolentSprites.dataKey);
                else
                    item.exclusiveString = "";
            }
        }
    }

    [HarmonyPatch(typeof(SoundManager), "PlayUI_MoveItem")]
    class Patch_PlayMoveItemSound
    {
        static bool Prefix()
        {
            return !Environment.StackTrace.Contains("HelperSprite.tryDepositHeld");
        }
    }

    [HarmonyPatch(typeof(AI_NetworkBehaviour_Domestic_Resource))]
    class Patch_Domestic_Resource
    {
        [HarmonyPatch("Start")]
        [HarmonyPostfix]
        static void Start(AI_NetworkBehaviour_Domestic_Resource __instance) => BenevolentSprites.animals.Add(__instance);


        [HarmonyPatch("OnDestroy")]
        [HarmonyPostfix]
        static void OnDestroy(AI_NetworkBehaviour_Domestic_Resource __instance) => BenevolentSprites.animals.Remove(__instance);
    }

    [HarmonyPatch(typeof(NetworkIDManager), new[] { typeof(MonoBehaviour_ID_Network), typeof(Type), typeof(NetworkIDTag) })]
    class Patch_NetworkedObject
    {
        [HarmonyPatch("AddNetworkID")]
        [HarmonyPostfix]
        static void Add(MonoBehaviour_ID_Network networkID, NetworkIDTag tag)
        {
            if (networkID is Seagull)
                BenevolentSprites.seagulls.Add((Seagull)networkID);
            if (tag == NetworkIDTag.ChickenEgg && networkID is PickupItem_Networked)
                BenevolentSprites.eggs.Add((PickupItem_Networked)networkID);
        }


        [HarmonyPatch("RemoveNetworkID")]
        [HarmonyPostfix]
        static void Remove(MonoBehaviour_ID_Network networkID, NetworkIDTag tag)
        {
            if (networkID is Seagull)
                BenevolentSprites.seagulls.Remove((Seagull)networkID);
            if (tag == NetworkIDTag.ChickenEgg && networkID is PickupItem_Networked)
                BenevolentSprites.eggs.Remove((PickupItem_Networked)networkID);
        }
    }

    [HarmonyPatch(typeof(Block), "OnFinishedPlacement")]
    class Patch_Block
    {
        static List<string> fails = new List<string>();
        static void Postfix(Block __instance)
        {
            if (__instance is Block_Foundation_ItemNet)
                BenevolentSprites.itemnets.Add((Block_Foundation_ItemNet)__instance);
            if (__instance.GetComponent<BeeHive>())
                BenevolentSprites.beehives.Add(__instance.GetComponent<BeeHive>());
            if (__instance.GetComponent<CookingTable_Recipe_UI>())
                BenevolentSprites.recipes.Add(__instance.GetComponent<CookingTable_Recipe_UI>());
            if (__instance.GetComponent<CookingTable>())
                BenevolentSprites.tables.Add(__instance.GetComponent<CookingTable>());
            if (__instance.GetComponent<Block_CookingStand>())
                BenevolentSprites.stands.Add(__instance.GetComponent<Block_CookingStand>());
            foreach (var c in __instance.GetComponents<MonoBehaviour_ID_Network>())
            {
                foreach (var ta in c.FindAll<Tank[]>())
                    foreach (var t in ta)
                        if (t != null && !BenevolentSprites.tanks.Exists((x) => x.Tank == t))
                            try { BenevolentSprites.tanks.Add(new TankAccess(t)); } catch (Exception e) { if (fails.AddUniqueOnly(t + " on " + __instance)) Debug.LogError("Failed to generate access data for " + t + " on " + __instance + "\n" + e); }
                foreach (var t in c.FindAll<Tank>())
                    if (t != null && !BenevolentSprites.tanks.Exists((x) => x.Tank == t))
                        try { BenevolentSprites.tanks.Add(new TankAccess(t)); } catch (Exception e) { if (fails.AddUniqueOnly(t + " on " + __instance)) Debug.LogError("Failed to generate access data for " + t + " on " + __instance + "\n" + e); }
            }
        }
    }

    [HarmonyPatch]
    class Patch_InventoryOverrides
    {
        public static GameObject ignore = null;
        [HarmonyPatch(typeof(Hotbar), "ReselectCurrentSlot")]
        [HarmonyPrefix]
        static bool reselect(Hotbar __instance) => __instance.gameObject != ignore;
        [HarmonyPatch(typeof(InventoryPickup), "ShowItem")]
        [HarmonyPrefix]
        static bool show(InventoryPickup __instance) => __instance.gameObject != ignore;
        [HarmonyPatch(typeof(PlayerInventory), "HandleNewItemAdded")]
        [HarmonyPrefix]
        static bool handle(PlayerInventory __instance) => __instance.gameObject != ignore;
    }

    [HarmonyPatch(typeof(PlayerAnimator), "SetAnimation", typeof(PlayerAnimation), typeof(bool))]
    class Patch_PlayerAnimator
    {
        public static bool disable = false;
        static bool Prefix() => !disable;
    }

    [HarmonyPatch(typeof(Block_CookingStand), "GetCookingSlotsForItem")]
    class Patch_GetCookingSlots
    {
        public static bool spriteCall = false;
        static bool Prefix(Block_CookingStand __instance, Block_CookingStand.CookingSlotCollection[] ___cookingSlotCollections, Item_Base itemToInsert, out CookingSlot[] __result)
        {
            bool CanInsert(CookingSlot slot) => !slot.IsBusy && slot.CanCookItem(itemToInsert) && (!spriteCall || !FireSprite.IsTargeted(slot));
            if (itemToInsert)
            {
                if (itemToInsert.settings_cookable.CookingSlotsRequired <= 1)
                    for (int i = 0; i < __instance.cookingSlots.Length; i++)
                    {
                        if (CanInsert(__instance.cookingSlots[i]))
                        {
                            __result = new[] { __instance.cookingSlots[i] };
                            return false;
                        }
                    }
                else
                    foreach (var col in ___cookingSlotCollections)
                    {
                        var f = new List<CookingSlot>();
                        for (int i = 0; i < col.cookingSlots.Length; i++)
                        {
                            if (CanInsert(col.cookingSlots[i]))
                                f.Add(col.cookingSlots[i]);
                            else
                                f.Clear();
                            if (f.Count == itemToInsert.settings_cookable.CookingSlotsRequired)
                            {
                                __result = f.ToArray();
                                return false;
                            }
                        }
                    }
            }
            __result = null;
            return false;
        }
    }

    struct CookingSlotTargets
    {
        public static CookingSlotTargets Null = new CookingSlotTargets() { slotInds = new int[0], stand = null };
        public int[] slotInds;
        public Block_CookingStand stand;
        public uint ObjectIndex
        {
            get => stand == null ? 0 : stand.ObjectIndex;
            set
            {
                foreach (var s in BenevolentSprites.stands)
                    if (s.ObjectIndex == value)
                    {
                        stand = s;
                        return;
                    }
            }
        }
        public CookingSlot Slot
        {
            get => stand && slotInds != null && slotInds.Length > 0 ? stand.cookingSlots[slotInds[0]] : null;
            set
            {
                if (value == null)
                {
                    stand = null;
                    slotInds = new int[0];
                    return;
                }
                if (stand)
                    slotInds = new[] { stand.GetIndexOfCookingSlot(value) };
                if (slotInds == null || slotInds.Length == 0 || slotInds[0] == -1)
                {
                    var nStand = value.GetComponentInParent<Block_CookingStand>();
                    if (nStand && nStand != stand)
                    {
                        slotInds = new[] { nStand.GetIndexOfCookingSlot(value) };
                        stand = nStand;
                    }
                }
                if (slotInds == null || slotInds.Length == 0 || slotInds[0] == -1)
                    throw new NullReferenceException();
            }
        }
        public List<CookingSlot> Slots
        {
            get
            {
                var slots = new List<CookingSlot>();
                if (stand && slotInds != null)
                    foreach (var i in slotInds)
                        slots.Add(stand.cookingSlots[i]);
                return slots;
            }
            set
            {
                if (value == null || value.Count == 0)
                {
                    stand = null;
                    slotInds = new int[0];
                    return;
                }
                var nStand = stand;
                if (!stand || stand.GetIndexOfCookingSlot(value[0]) == -1)
                    nStand = value[0].GetComponentInParent<Block_CookingStand>();
                if (!nStand)
                    throw new IndexOutOfRangeException();
                var inds = new int[value.Count];
                for (int i = 0; i < value.Count; i++)
                {
                    inds[i] = nStand.GetIndexOfCookingSlot(value[i]);
                    if (inds[i] == -1)
                        throw new IndexOutOfRangeException();
                }
                stand = nStand;
                slotInds = inds;
            }
        }
        public CookingSlotTargets(Block_CookingStand Stand, int SlotIndex)
        {
            stand = Stand;
            slotInds = new[] { SlotIndex };
        }
        public CookingSlotTargets(uint objectIndex, int SlotIndex) : this(null, SlotIndex)
        {
            ObjectIndex = objectIndex;
        }
        public CookingSlotTargets(CookingSlot slot)
        {
            stand = null;
            slotInds = null;
            Slot = slot;
        }
        public CookingSlotTargets(List<CookingSlot> slots)
        {
            stand = null;
            slotInds = null;
            Slots = slots;
        }

        public override bool Equals(object obj)
        {
            if (obj is CookingSlotTargets)
                return Equals((CookingSlotTargets)obj);
            return base.Equals(obj);
        }

        public bool Equals(CookingSlotTargets target)
        {
            return target.ObjectIndex == ObjectIndex && slotInds.Any(x => target.slotInds.Contains(x));
        }

        public static implicit operator CookingSlotTargets(CookingSlot slot) => new CookingSlotTargets(slot);
        public static implicit operator CookingSlotTargets(List<CookingSlot> slots) => new CookingSlotTargets(slots);
    }
    public class TankAccess
    {
        MonoBehaviour_ID_Network receiver;
        Tank tank;
        Traverse<List<Item_Base>> outTypes;
        Traverse<List<Item_Base>> inTypes;
        Traverse<Item_Base> outputItem;
        Traverse<float> tankAmt;
        Traverse<Tank.TankAcceptance> accept;
        PipeSocket_Tank[] pipes;
        Traverse harvestAmount;
        bool isExtractorOutput;

        public MonoBehaviour_ID_Network Receiver => receiver;
        public Tank Tank => tank;
        public List<Item_Base> acceptableOutputTypes => outTypes.Value;
        public List<Item_Base> acceptableTypes => inTypes.Value;
        public float currentTankAmount { get => tankAmt.Value; set => tank.ModifyTankRPC(value - tankAmt.Value, null); }
        public Tank.TankAcceptance tankAcceptance => accept.Value;
        public bool HasOutput => isExtractorOutput || (Tank.TankHasOutput() && tankAcceptance == Tank.TankAcceptance.Output);
        public bool HasInput => Tank.TankHasInput() && tankAcceptance == Tank.TankAcceptance.Input;
        public bool IsConnectedToPipe => pipes != null && pipes.Any(x => x?.pipeGroup?.GetPipes()?.Count > 1);
        public int HarvestAmount => harvestAmount == null ? 0 : harvestAmount.GetValue<int>();
        public Item_Base OutputItem => outputItem.Value;
        public TankAccess(Tank Tank) : this(Traverse.Create(Tank).Field("messageReciever").GetValue<MonoBehaviour_ID_Network>(), Tank) { }
        public TankAccess(MonoBehaviour_ID_Network Reciever, Tank Tank)
        {
            receiver = Reciever;
            tank = Tank;
            outTypes = Traverse.Create(tank).Field<List<Item_Base>>("acceptableOutputTypes");
            inTypes = Traverse.Create(tank).Field<List<Item_Base>>("acceptableTypes");
            tankAmt = Traverse.Create(tank).Field<float>("currentTankAmount");
            accept = Traverse.Create(tank).Field<Tank.TankAcceptance>("tankAcceptance");
            var extractor = receiver.GetComponent<Placeable_Extractor>();
            if (extractor)
            {
                isExtractorOutput = extractor.outputTank == tank;
                harvestAmount = Traverse.Create(extractor).Method("HarvestAmount");
                outputItem = Traverse.Create(extractor).Field<Item_Base>("itemTypeOnHarvest");
            }
            pipes = tank.GetComponentInParent<Block>()?.GetComponentsInChildren<PipeSocket_Tank>().ToList().FindAll(x => x.socketType.ToString().StartsWith("Output_") && x.connectedTank == tank).ToArray();
        }
    }

    public struct MessageType
    {
        public const int ChannelID = 8;
        public const Messages MessageID = (Messages)23468;
        public const int Create = 0;
        public const int Target = 1;
        public const int Kill = 2;
        public const int Recreate = 3;
        public const int PlantSeed = 4;
        public const int ClearCooker = 5;
        public const int InsertCooker = 6;
        public const int AddFuel = 7;
        public const int InsertTable = 8;
        public const int ClearTable = 9;
        public const int ClearAll = 10;
        public const int ClearFish = 11;
        public static Dictionary<int, ConstructorInfo> Contructor = new Dictionary<int, ConstructorInfo>
        {
            [Create] = typeof(Message_Sprite_Create).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [Target] = typeof(Message_Sprite_SetTarget).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [Kill] = typeof(Message_Sprite_Kill).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [Recreate] = typeof(Message_Sprite_Recreate).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [PlantSeed] = typeof(Message_Sprite_PlantSeed).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [ClearCooker] = typeof(Message_Sprite_ClearCooker).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [InsertCooker] = typeof(Message_Sprite_InsertCooker).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [AddFuel] = typeof(Message_Sprite_AddFuel).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [InsertTable] = typeof(Message_Sprite_InsertTable).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [ClearTable] = typeof(Message_Sprite_ClearTable).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [ClearAll] = typeof(Message_Sprite_ClearAll).GetConstructor(new[] { typeof(Message_InitiateConnection) }),
            [ClearFish] = typeof(Message_Sprite_ClearFish).GetConstructor(new[] { typeof(Message_InitiateConnection) })
        };
        public static Network_Player DummyPlayer;
        static MessageType()
        {
            var g = new GameObject("");
            g.SetActive(false);
            Object.DontDestroyOnLoad(g);
            DummyPlayer = g.AddComponent<Network_Player>();
            Traverse.Create(DummyPlayer).Field("animator").SetValue(g.AddComponent<PlayerAnimator>());
        }

        public static string getName(int msgId)
        {
            switch (msgId)
            {
                case 0:
                    return "Create Sprite";
                case 1:
                    return "Set Sprite Target";
                case 2:
                    return "Kill Sprite";
                case 3:
                    return "Create Sprite from Serial";
                case 4:
                    return "Plant Seed";
                case 5:
                    return "Empty Cooking Stand Slots";
                case 6:
                    return "Set Cooking Stand Slots";
                case 7:
                    return "Add Fuel";
                case 8:
                    return "Insert Cooking Table Recipe";
                case 9:
                    return "Empty Cooking Table";
                case 10:
                    return "Empty Item Net";
                case 11:
                    return "Empty Fishing Net";
            }
            return "Unknown (" + msgId + ")";
        }
    }

    abstract class Message_Sprite
    {
        public abstract void Use();
    }

    class Message_Sprite_Create : Message_Sprite
    {
        public Message_InitiateConnection Message
        {
            get
            {
                var data = new List<byte>();
                data.AddRange(spriteIndex.Bytes());
                data.AddRange(boxIndex.Bytes());
                data.AddRange(slotIndex.Bytes());
                return new Message_InitiateConnection(MessageType.MessageID, MessageType.Create, data.String());
            }
        }
        public Storage_Small Box
        {
            get
            {
                foreach (var box in StorageManager.allStorages)
                    if (box.ObjectIndex == boxIndex)
                        return box;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find box with index {boxIndex}");
                return null;
            }
        }
        public Slot Slot
        {
            get
            {
                var slots = Box?.GetInventoryReference()?.allSlots;
                if (slots != null && slotIndex >= 0 && slots.Count > slotIndex)
                    return slots[slotIndex];
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find slot with index {slotIndex}");
                return null;
            }
        }
        public HelperSprite Sprite
        {
            get
            {
                foreach (var sprite in BenevolentSprites.sprites)
                    if (sprite.ObjectIndex == spriteIndex)
                        return sprite;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find sprite with index {spriteIndex}");
                return null;
            }
        }
        public uint SpriteIndex => spriteIndex;
        uint spriteIndex;
        uint boxIndex;
        int slotIndex;
        public Message_Sprite_Create(HelperSprite sprite)
        {
            spriteIndex = sprite.ObjectIndex;
            boxIndex = sprite.box.ObjectIndex;
            slotIndex = sprite.box.GetInventoryReference().allSlots.IndexOf(sprite.store);
        }
        public Message_Sprite_Create(Message_InitiateConnection message)
        {
            var data = message.password.Bytes();
            spriteIndex = data.UInteger(0);
            boxIndex = data.UInteger(4);
            slotIndex = data.Integer(8);
        }

        public override void Use() => BenevolentSprites.CreateSprite(Box, Slot, SpriteIndex);
    }

    class Message_Sprite_SetTarget : Message_Sprite
    {
        public Message_InitiateConnection Message
        {
            get
            {
                var data = new List<byte>();
                data.AddRange(spriteIndex.Bytes());
                data.AddRange(targetIndex.Bytes());
                data.AddRange(targetOffset.Bytes());
                return new Message_InitiateConnection(MessageType.MessageID, MessageType.Target, data.String());
            }
        }
        public Vector3 Offset => targetOffset;
        public MonoBehaviour_ID Target => Sprite.FindTarget(targetIndex);
        public HelperSprite Sprite
        {
            get
            {
                foreach (var sprite in BenevolentSprites.sprites)
                    if (sprite.ObjectIndex == spriteIndex)
                        return sprite;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find sprite with index {spriteIndex}");
                return null;
            }
        }
        uint spriteIndex;
        uint targetIndex;
        Vector3 targetOffset;
        public Message_Sprite_SetTarget(HelperSprite sprite, MonoBehaviour_ID Target, Vector3 TargetOffset)
        {
            spriteIndex = sprite.ObjectIndex;
            targetIndex = Target.ObjectIndex;
            targetOffset = TargetOffset;
        }
        public Message_Sprite_SetTarget(Message_InitiateConnection message)
        {
            var data = message.password.Bytes();
            spriteIndex = data.UInteger(0);
            targetIndex = data.UInteger(4);
            targetOffset = data.Vector3(8);
        }

        public override void Use() => Sprite.SetTargetNetwork(Target, Offset);
    }

    class Message_Sprite_Kill : Message_Sprite
    {
        public Message_InitiateConnection Message => new Message_InitiateConnection(MessageType.MessageID, MessageType.Kill, spriteIndex.Bytes().String());
        public HelperSprite Sprite
        {
            get
            {
                foreach (var sprite in BenevolentSprites.sprites)
                    if (sprite.ObjectIndex == spriteIndex)
                        return sprite;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find sprite with index {spriteIndex}");
                return null;
            }
        }
        uint spriteIndex;
        public Message_Sprite_Kill(HelperSprite sprite)
        {
            spriteIndex = sprite.ObjectIndex;
        }
        public Message_Sprite_Kill(Message_InitiateConnection message)
        {
            spriteIndex = message.password.Bytes().UInteger(0);
        }

        public override void Use() => Sprite.Kill();
    }

    class Message_Sprite_Recreate : Message_Sprite
    {
        public Message_InitiateConnection Message
        {
            get
            {
                var data = new List<byte>();
                data.AddRange(spriteIndex.Bytes());
                data.AddRange(boxIndex.Bytes());
                data.AddRange(slotIndex.Bytes());
                data.AddRange(targetIndex.Bytes());
                data.AddRange(targetOffset.Bytes());
                data.AddRange(position.Bytes());
                return new Message_InitiateConnection(MessageType.MessageID, MessageType.Recreate, data.String());
            }
        }
        public Storage_Small Box
        {
            get
            {
                foreach (var box in StorageManager.allStorages)
                    if (box.ObjectIndex == boxIndex)
                        return box;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find box with index {boxIndex}");
                return null;
            }
        }
        public Slot Slot
        {
            get
            {
                var slots = Box?.GetInventoryReference()?.allSlots;
                if (slots != null && slotIndex >= 0 && slots.Count > slotIndex)
                    return slots[slotIndex];
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find slot with index {slotIndex}");
                return null;
            }
        }
        public HelperSprite Sprite
        {
            get
            {
                foreach (var sprite in BenevolentSprites.sprites)
                    if (sprite.ObjectIndex == spriteIndex)
                        return sprite;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find sprite with index {spriteIndex}");
                return null;
            }
        }
        public Vector3 Offset => targetOffset;
        public Vector3 Position => position;
        public uint TargetIndex => targetIndex;
        public uint SpriteIndex => spriteIndex;
        uint spriteIndex;
        uint boxIndex;
        int slotIndex;
        uint targetIndex;
        Vector3 targetOffset;
        Vector3 position;
        public Message_Sprite_Recreate(HelperSprite sprite)
        {
            spriteIndex = sprite.ObjectIndex;
            boxIndex = sprite.box.ObjectIndex;
            slotIndex = sprite.box.GetInventoryReference().allSlots.IndexOf(sprite.store);
            targetIndex = sprite.targetObject.GetComponent<MonoBehaviour_ID>().ObjectIndex;
            targetOffset = sprite.targetPosition;
            position = sprite.gameObject.transform.localPosition;
        }
        public Message_Sprite_Recreate(Message_InitiateConnection message)
        {
            var data = message.password.Bytes();
            spriteIndex = data.UInteger(0);
            boxIndex = data.UInteger(4);
            slotIndex = data.Integer(8);
            targetIndex = data.UInteger(12);
            targetOffset = data.Vector3(16);
            position = data.Vector3(28);
        }

        public override void Use()
        {
            var sprite = BenevolentSprites.CreateSprite(Box, Slot, SpriteIndex);
            sprite.gameObject.transform.localPosition = Position;
            sprite.SetTarget(sprite.FindTarget(TargetIndex).transform, Offset);
        }
    }

    class Message_Sprite_PlantSeed : Message_Sprite
    {
        public Message_InitiateConnection Message
        {
            get
            {
                var data = new List<byte>();
                data.AddRange(cropIndex.Bytes());
                data.AddRange(itemIndex.Bytes());
                data.AddRange(objectIndex.Bytes());
                data.Add((byte)(water ? 1 : 0));
                return new Message_InitiateConnection(MessageType.MessageID, MessageType.PlantSeed, data.String());
            }
        }
        public Cropplot Plot
        {
            get
            {
                foreach (var plot in PlantManager.allCropplots)
                    if (plot.ObjectIndex == cropIndex)
                        return plot;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find crop with index {cropIndex}");
                return null;
            }
        }
        public int ItemIndex => itemIndex;
        public uint ObjectIndex => objectIndex;
        public bool WaterCrop => water;
        uint cropIndex;
        int itemIndex;
        uint objectIndex;
        bool water;
        public Message_Sprite_PlantSeed(Cropplot Plot, int ItemIndex, uint ObjectIndex, bool WaterCrop)
        {
            cropIndex = Plot.ObjectIndex;
            itemIndex = ItemIndex;
            objectIndex = ObjectIndex;
            water = WaterCrop;
        }
        public Message_Sprite_PlantSeed(Message_InitiateConnection message)
        {
            var data = message.password.Bytes();
            cropIndex = data.UInteger(0);
            itemIndex = data.Integer(4);
            objectIndex = data.UInteger(8);
            water = data[12] == 1;
        }

        public override void Use()
        {
            var crop = Plot;
            crop.plantManager().PlantSeed(crop, crop.plantManager().GetPlantByIndex(ItemIndex), ObjectIndex, WaterCrop, false);
        }
    }

    class Message_Sprite_ClearCooker : Message_Sprite
    {
        public Message_InitiateConnection Message
        {
            get
            {
                var data = new List<byte>();
                data.AddRange(standIndex.Bytes());
                data.AddRange(slotIndex.Bytes());
                return new Message_InitiateConnection(MessageType.MessageID, MessageType.ClearCooker, data.String());
            }
        }
        public Block_CookingStand Stand
        {
            get
            {
                foreach (var stand in BenevolentSprites.stands)
                    if (stand.ObjectIndex == standIndex)
                        return stand;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find cooking stand with index {standIndex}");
                return null;
            }
        }
        public int Slot => slotIndex;
        uint standIndex;
        int slotIndex;
        public Message_Sprite_ClearCooker(Block_CookingStand Stand, CookingSlot Slot)
        {
            standIndex = Stand.ObjectIndex;
            slotIndex = Stand.GetIndexOfCookingSlot(Slot);
        }
        public Message_Sprite_ClearCooker(Message_InitiateConnection message)
        {
            var data = message.password.Bytes();
            standIndex = data.UInteger(0);
            slotIndex = data.Integer(4);
        }

        public override void Use()
        {
            var stand = Stand;
            Patch_PlayerAnimator.disable = true;
            stand.CollectItem(stand.cookingSlots[Slot], MessageType.DummyPlayer);
            Patch_PlayerAnimator.disable = false;
        }
    }

    class Message_Sprite_InsertCooker : Message_Sprite
    {
        public Message_InitiateConnection Message
        {
            get
            {
                var data = new List<byte>();
                data.AddRange(slots.Bytes());
                data.AddRange(itemIndex.Bytes());
                return new Message_InitiateConnection(MessageType.MessageID, MessageType.InsertCooker, data.String());
            }
        }
        public CookingSlotTargets Slots => slots;
        public Item_Base Item => ItemManager.GetItemByIndex(itemIndex);
        CookingSlotTargets slots;
        int itemIndex;
        public Message_Sprite_InsertCooker(CookingSlotTargets Slots, Item_Base Item)
        {
            slots = Slots;
            itemIndex = Item.UniqueIndex;
        }
        public Message_Sprite_InsertCooker(Message_InitiateConnection message)
        {
            var data = message.password.Bytes();
            slots = data.CookingSlotTargets(0);
            itemIndex = data.Integer(12);
        }

        public override void Use()
        {
            Patch_PlayerAnimator.disable = true;
            Slots.stand.InsertItem(Item, Slots.Slots.ToArray(), MessageType.DummyPlayer);
            Patch_PlayerAnimator.disable = false;
        }
    }

    class Message_Sprite_AddFuel : Message_Sprite
    {
        public Message_InitiateConnection Message
        {
            get
            {
                var data = new List<byte>();
                data.AddRange(objectIndex.Bytes());
                data.AddRange(amount.Bytes());
                data.AddRange(type.Bytes());
                return new Message_InitiateConnection(MessageType.MessageID, MessageType.AddFuel, data.String());
            }
        }
        public Fuel Fuel
        {
            get
            {
                if (type == 1)
                    foreach (var stand in BenevolentSprites.stands)
                        if (stand.ObjectIndex == objectIndex)
                            return stand.fuel;
                if (type == 2)
                    return NetworkIDManager.GetNetworkIDFromObjectIndex<CookingTable>(objectIndex).GetComponentInChildren<FuelNetwork>().Fuel;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find cooking stand or table with index {objectIndex}");
                return null;
            }
        }
        public int Amount => amount;
        uint objectIndex;
        int type;
        int amount;
        public Message_Sprite_AddFuel(Block_CookingStand Stand, int Amount)
        {
            objectIndex = Stand.ObjectIndex;
            amount = Amount;
            type = 1;
        }
        public Message_Sprite_AddFuel(CookingTable Table, int Amount)
        {
            objectIndex = Table.ObjectIndex;
            amount = Amount;
            type = 2;
        }
        public Message_Sprite_AddFuel(Message_InitiateConnection message)
        {
            var data = message.password.Bytes();
            objectIndex = data.UInteger(0);
            amount = data.Integer(4);
            type = data.Integer(8);
        }

        public override void Use() => Fuel.AddFuel(Amount);
    }

    class Message_Sprite_InsertTable : Message_Sprite
    {
        public Message_InitiateConnection Message
        {
            get
            {
                var data = new List<byte>();
                data.AddRange(tableIndex.Bytes());
                data.AddRange(recipeIndex.Bytes());
                return new Message_InitiateConnection(MessageType.MessageID, MessageType.InsertTable, data.String());
            }
        }
        public CookingTable Table => NetworkIDManager.GetNetworkIDFromObjectIndex<CookingTable>(tableIndex);
        public SO_CookingTable_Recipe Recipe
        {
            get
            {
                foreach (var recipe in BenevolentSprites.allRecipes)
                    if (recipe.RecipeIndex == recipeIndex)
                        return recipe;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find recipe with index {recipeIndex}");
                return null;
            }
        }
        uint tableIndex;
        uint recipeIndex;
        public Message_Sprite_InsertTable(CookingTable Table, SO_CookingTable_Recipe Recipe)
        {
            tableIndex = Table.ObjectIndex;
            recipeIndex = Recipe.RecipeIndex;
        }
        public Message_Sprite_InsertTable(Message_InitiateConnection message)
        {
            var data = message.password.Bytes();
            tableIndex = data.UInteger(0);
            recipeIndex = data.UInteger(4);
        }

        public override void Use() => Table.ForceStart(Recipe);
    }

    class Message_Sprite_ClearTable : Message_Sprite
    {
        public Message_InitiateConnection Message
        {
            get
            {
                var data = new List<byte>();
                data.AddRange(tableIndex.Bytes());
                data.AddRange(amount.Bytes());
                return new Message_InitiateConnection(MessageType.MessageID, MessageType.ClearTable, data.String());
            }
        }
        public CookingTable Table => NetworkIDManager.GetNetworkIDFromObjectIndex<CookingTable>(tableIndex);
        public int Amount => amount;
        uint tableIndex;
        int amount;
        public Message_Sprite_ClearTable(CookingTable Table, int Amount)
        {
            tableIndex = Table.ObjectIndex;
            amount = Amount;
        }
        public Message_Sprite_ClearTable(Message_InitiateConnection message)
        {
            var data = message.password.Bytes();
            tableIndex = data.UInteger(0);
            amount = data.Integer(4);
        }

        public override void Use() => Table.Remove(Amount);
    }

    class Message_Sprite_ClearAll : Message_Sprite
    {
        public Message_InitiateConnection Message => new Message_InitiateConnection(MessageType.MessageID, MessageType.ClearAll, collectorIndex.Bytes().String());
        public ItemCollector Collector
        {
            get
            {
                foreach (var collector in Object.FindObjectsOfType<ItemCollector>())
                    if (collector.ObjectIndex == collectorIndex)
                        return collector;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find collector with index {collectorIndex}");
                return null;
            }
        }
        uint collectorIndex;
        public Message_Sprite_ClearAll(ItemCollector Collector) => collectorIndex = Collector.ObjectIndex;
        public Message_Sprite_ClearAll(Message_InitiateConnection message) => collectorIndex = message.password.Bytes().UInteger(0);

        public override void Use() => Traverse.Create(Collector).Method("ClearCollectedItems", new[] { typeof(Network_Player) }, new object[] { null }).GetValue();
    }

    class Message_Sprite_ClearFish : Message_Sprite
    {
        public Message_InitiateConnection Message => new Message_InitiateConnection(MessageType.MessageID, MessageType.ClearFish, fisherIndex.Bytes().String());
        public Block netBlock
        {
            get
            {
                foreach (var block in BlockCreator.GetPlacedBlocks())
                    if (block.ObjectIndex == fisherIndex)
                        return block;
                Debug.LogWarning($"[Benevolent Sprites]: Failed to find fishing net with index {fisherIndex}");
                return null;
            }
        }
        uint fisherIndex;
        public Message_Sprite_ClearFish(Block block) => fisherIndex = block.ObjectIndex;
        public Message_Sprite_ClearFish(Message_InitiateConnection message) => fisherIndex = message.password.Bytes().UInteger(0);

        public override void Use()
        {
            var net = Traverse.Create(CleanerSprite.GetFishNetFromBlock(netBlock.transform));
            foreach (var c in net.Field("caughtFish").GetValue<Component[]>())
                if (c?.GetType().Name == "objectEnabler")
                    Traverse.Create(c).Method("DisableModels", new object[] { }).GetValue();
            var a = net.Field<Item_Base[]>("caughtFishItem");
            a.Value = new Item_Base[a.Value.Length];
            net.Field("fishCount").SetValue(0);
            net.Field("netFull").SetValue(false);
        }
    }
}